/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gbmsapi_simpleapplication;
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

import com.sun.jna.Library;
import com.sun.jna.Native;
import com.sun.jna.Platform;
import com.sun.jna.Pointer;
import com.sun.jna.Callback;
import com.sun.jna.ptr.IntByReference;
import com.sun.jna.ptr.LongByReference;
import com.sun.jna.ptr.ByteByReference;
import java.io.*;

import GBMSAPI_JAVA_LibraryFunctions.*;
import GBMSAPI_JAVA_LibraryFunctions.GBMSAPI_JAVA_DLL_WRAPPER.GBMSAPI_Library;
import GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes;
import GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_DeviceCharacteristicsDefines.*;
import GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_AcquisitionProcessDefines.*;

/**
 *
 * @author andrea
 */
public class GB_ExampleAcquisitionCallback implements GBMSAPI_JAVA_AcquisitionEventsManagerCallbackInterface {

    public int invoke(
	    int OccurredEventCode,
	    int GetFrameErrorCode,
	    int EventInfo,
	    Pointer FramePtr,
	    int FrameSizeX,
	    int FrameSizeY,
	    double CurrentFrameRate,
	    double NominalFrameRate,
	    int GB_Diagnostic,
	    Pointer UserDefinedParameters) {
	if (OccurredEventCode == GBMSAPI_JAVA_AcquisitionEvents.GBMSAPI_JAVA_AE_VALID_FRAME_ACQUIRED) {
	    GB_ExampleUtils.Global_AcquisitionValFrameCounter++;
	    System.out.println("Frame num: " + GB_ExampleUtils.Global_AcquisitionValFrameCounter);
	    if (GB_Diagnostic != 0)
	    {
		System.out.println("Diagnostic: " + GB_Diagnostic);
		GBMSAPI_Library.INSTANCE.GBMSAPI_VUI_LED_BlinkDuringAcquisition(1);
		GBMSAPI_Library.INSTANCE.GBMSAPI_SetAutoCaptureBlocking(1);
	    }
	    else
	    {
		GBMSAPI_Library.INSTANCE.GBMSAPI_VUI_LED_BlinkDuringAcquisition(0);
		GBMSAPI_Library.INSTANCE.GBMSAPI_SetAutoCaptureBlocking(0);
	    }
	    //////////////////////////////////////////////
	    // Following contrast calculation shows how
	    // the fact that in Java unsigned types don't
	    // exist should be treated and the
	    // 2-complement calculation for a byte
	    //////////////////////////////////////////////
	    ByteByReference pContrast = new ByteByReference();
	    GBMSAPI_Library.INSTANCE.GBMSAPI_GetFingerprintContrast(pContrast);
	    int Contrast;
	    if (pContrast.getValue() >= 0)
	    {
		Contrast = pContrast.getValue();
	    }
	    else
	    {
		Contrast = 256 + pContrast.getValue();
	    }
	    System.out.println("Contrast: " + Contrast);
	}
	else if (OccurredEventCode == GBMSAPI_JAVA_AcquisitionEvents.GBMSAPI_JAVA_AE_ACQUISITION_END) {
	    System.out.println("Acquisition end!");
	    GBMSAPI_Library.INSTANCE.GBMSAPI_ImageFinalization(FramePtr);
	    GB_ExampleUtils.FrameBuffer = FramePtr.getByteArray(0, FrameSizeX * FrameSizeY);
	    if (GB_ExampleUtils.FrameBuffer != null) {
		FileOutputStream fos;
		DataOutputStream ds;
		try {
		    // save on file
		    fos = new FileOutputStream("x.raw");

		    // Wrap the FileOutputStream with a
		    // DataOutputStream to obtain its writeInt()
		    // method.
		    ds = new DataOutputStream(fos);
		    ds.write(GB_ExampleUtils.FrameBuffer);
		} catch (Exception ex) {
		    System.out.println("Exception in GB_ExampleAcquisitionCallback: "
			    + ex.getMessage());
		}
	    }
	    GB_ExampleUtils.Global_AcquisitionState = GB_ExampleUtils.Global_AcquisitionStateVal_Idle;
	}
	else if (OccurredEventCode == GBMSAPI_JAVA_AcquisitionEvents.GBMSAPI_JAVA_AE_ACQUISITION_ERROR) {
	    System.out.println("Acquisition error!");
	    GB_ExampleUtils.Global_AcquisitionState = GB_ExampleUtils.Global_AcquisitionStateVal_Idle;
	}
	else if (OccurredEventCode == GBMSAPI_JAVA_AcquisitionEvents.GBMSAPI_JAVA_AE_PREVIEW_PHASE_END) {
	    System.out.println("Preview End!");
	    if (GB_ExampleUtils.Global_SoundAvailable == true)
	    {
		GBMSAPI_Library.INSTANCE.GBMSAPI_Sound((byte)12,(byte)2,(byte)1);
	    }
	    GB_ExampleUtils.Global_AcquisitionState = GB_ExampleUtils.Global_AcquisitionStateVal_Acquisition;
	}
	else if (OccurredEventCode == GBMSAPI_JAVA_AcquisitionEvents.GBMSAPI_JAVA_AE_SCANNER_STARTED) {
	    GB_ExampleUtils.Global_AcquisitionState = GB_ExampleUtils.Global_AcquisitionStateVal_Preview;
	    GB_ExampleUtils.Global_AcquisitionValFrameCounter = 0;
	}
	else {
	    return 0;
	}

	return 1;
    }
}