/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package GBMSAPI_JAVA_LibraryFunctions;

import com.sun.jna.Library;
import com.sun.jna.Native;
import com.sun.jna.Pointer;
import com.sun.jna.ptr.IntByReference;
import com.sun.jna.ptr.ByteByReference;
import com.sun.jna.ptr.PointerByReference;
import GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_DeviceCharacteristicsDefines.GBMSAPI_JAVA_DeviceInfoStruct;
import com.sun.jna.ptr.DoubleByReference;

/**
 *
 * @author andrea
 */
public class GBMSAPI_JAVA_DLL_WRAPPER {

    /**
     *
     */
    public interface GBMSAPI_Library extends Library {

        /**
         * Inherited for loading native dll
         */
        GBMSAPI_Library INSTANCE = (GBMSAPI_Library) Native.loadLibrary("GBMSAPI", GBMSAPI_Library.class);

        /**
         *
         * @param AttachedDeviceList
         * @param AttachedDeviceNumber
         * @param USBErrorCode Native is an unsigned int32 see point (1) of
         * ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_GetAttachedDeviceList(
                GBMSAPI_JAVA_DeviceInfoStruct[] AttachedDeviceList,
                IntByReference AttachedDeviceNumber,
                IntByReference USBErrorCode);

        /**
         *
         * @param DeviceID Native is an unsigned byte see point (1) of
         * ReadME.txt file
         * @param DeviceSerialNumber
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_SetCurrentDevice(
                Byte DeviceID,
                String DeviceSerialNumber);

        /**
         *
         * @param DeviceID Native is an unsigned byte see point (1) of
         * ReadME.txt file
         * @param DeviceSerialNumber should be a String see point (2) of
         * ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_GetCurrentDevice(
                ByteByReference DeviceID,
                byte[] DeviceSerialNumber);

        /**
         *
         * @param ScannableTypesMask Native is a pointer to an unsigned int32
         * see point (1) of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_GetScannableTypes(
                IntByReference ScannableTypesMask);

        /**
         *
         * @param DeviceFeatures Native is a pointer to an unsigned int32 see
         * point (1) of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_GetDeviceFeatures(
                IntByReference DeviceFeatures);

        /**
         *
         * @param SupportedScanOptions Native is a pointer to an unsigned int32
         * see point (1) of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_GetSupportedScanOptions(
                IntByReference SupportedScanOptions);

        /**
         * VER 2.7.1.0
         *
         * @param RollAreaStandard
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_DeviceCharacteristicsDefines.GBMSAPI_JAVA_DeviceFeatures
         * @return
         *
         */
        int GBMSAPI_SetRollAreaStandard(
                int RollAreaStandard);

        /**
         *
         * @param OptionalExternalEquipment Native is a pointer to an unsigned
         * int32 see point (1) of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_GetOptionalExternalEquipment(
                IntByReference OptionalExternalEquipment);

        /**
         *
         * @param ObjectTypeToScan Native is an unsigned int32 see point (1) of
         * ReadME.txt file
         * @param AvailableImageInfo Native is a pointer to an unsigned int32
         * see point (1) of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_GetAvailableImageInfo(
                int ObjectTypeToScan,
                IntByReference AvailableImageInfo);

        /**
         *
         * @param ObjectTypeToScan Native is an unsigned int32 see point (1) of
         * ReadME.txt file
         * @param FlatScanArea Native is a boolean see point (3) of ReadME.txt
         * file
         * @param Preview Native is a boolean see point (3) of ReadME.txt file
         * @param ImageSizeX Native is a pointer to an unsigned int32 see point
         * (1) of ReadME.txt file
         * @param ImageSizeY Native is a pointer to an unsigned int32 see point
         * (1) of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_GetImageSize(
                int ObjectTypeToScan,
                int FlatScanArea,
                int Preview,
                IntByReference ImageSizeX,
                IntByReference ImageSizeY);

        /**
         * Ver 2700
         *
         * @param FlatScanArea Native is a boolean see point (3) of ReadME.txt
         * file
         * @param ImageSizeX Native is a pointer to an unsigned int32 see point
         * (1) of ReadME.txt file
         * @param ImageSizeY Native is a pointer to an unsigned int32 see point
         * (1) of ReadME.txt file
         * @return
         */
        int GBMSAPI_GetCalibrationImageSize(
                int FlatScanArea,
                IntByReference ImageSizeX,
                IntByReference ImageSizeY);

        /**
         *
         * @param ImageMaxSizeX Native is a pointer to an unsigned int32 see
         * point (1) of ReadME.txt file
         * @param ImageMaxSizeY Native is a pointer to an unsigned int32 see
         * point (1) of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_GetMaxImageSize(
                IntByReference ImageMaxSizeX,
                IntByReference ImageMaxSizeY);

        /**
         *
         * @param SelectImageTimeout Native is an unsigned int32 see point (1)
         * of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_SetSelectImageTimeout(
                int SelectImageTimeout);

        /**
         *
         * @param CompletenessThreshold Native is an unsigned byte see point (1)
         * of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_SetLowerHalfPalmCompletenessThreshold(
                byte CompletenessThreshold);

        /**
         * Ver 2700: VERY IMPORTANT NOTE Consider this function as obsolete: use
         *
         * @see GBMSAPI_JAVA_DLL_WRAPPER.GBMSAPI_SetFrameRateComplete
         *
         * @param FlatScanArea Native is a boolean see point (3) of ReadME.txt
         * file
         * @param FrameRate In order to get the range for this parameters,
         * @see GBMSAPI_JAVA_DLL_WRAPPER.GBMSAPI_GetFrameRateRange
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_SetFrameRate(
                int FlatScanArea,
                Double FrameRate);

        /**
         * Ver 2700
         *
         * @param FrameRateOptions
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_DeviceCharacteristicsDefines.GBMSAPI_JAVA_FrameRateOptions
         * @param MaxFrameRate
         * @param MinFrameRate
         * @param DefFrameRate
         * @return
         */
        int GBMSAPI_GetFrameRateRange(
                int FrameRateOptions,
                DoubleByReference MaxFrameRate,
                DoubleByReference MinFrameRate,
                DoubleByReference DefFrameRate);
        
        /**
         * VER 2.8.0.2
         * @param DeviceID Native is an unsigned byte see point (1) of
         * ReadME.txt file
         * @param FrameRateOptions
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_DeviceCharacteristicsDefines.GBMSAPI_JAVA_FrameRateOptions
         * @param RollAreaStandard
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_DeviceCharacteristicsDefines.GBMSAPI_JAVA_DeviceFeatures
         * @param MaxFrameRate
         * @param MinFrameRate
         * @param DefFrameRate
         * @return 
         */
        int GBMSAPI_GetFrameRateRange_Global(
                Byte DeviceID,
                int FrameRateOptions,
                int RollAreaStandard,
                DoubleByReference MaxFrameRate,
                DoubleByReference MinFrameRate,
                DoubleByReference DefFrameRate
                );

        /**
         *
         * @param FrameRateOptions Frame rate setting options
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_DeviceCharacteristicsDefines.GBMSAPI_JAVA_FrameRateOptions
         * @param FrameRate
         * @see GBMSAPI_JAVA_DLL_WRAPPER.GBMSAPI_GetFrameRateRange()
         * @return
         */
        int GBMSAPI_SetFrameRateComplete(
                int FrameRateOptions,
                Double FrameRate);

        /**
         *
         * @param Enable Native is a boolean see point (3) of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_EnableManualLEDControl(
                int Enable);

        /**
         * Ver 2500: added GBMSAPI_SetImageRotation(...) function
         *
         * @param ImageRotation
         *
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_SetImageRotation(
                int ImageRotation);
        
        /**
         * VER 2.9.0.0: added dry skin image enhancement feature
         * 
         * @param Enable: set to 1 to enable feature, 0 to disable
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_EnableDrySkinImgEnhance(byte Enable);

        /**
         *
         * @param ObjectToScan Native is an unsigned int32 see point (1) of
         * ReadME.txt file
         * @param OptionMask Native is an unsigned int32 see point (1) of
         * ReadME.txt file
         * @param AcquisitionEventsManagerCallbackPtr
         * @param AcquisitionEventsManagerParameters
         * @param DisplayOptionMask Native is an unsigned int32 see point (1) of
         * ReadME.txt file
         * @param ContrastLimitToDisplayOnLCD Native is an unsigned byte see
         * point (1) of ReadME.txt file
         * @param CompletenessLimitToDisplayOnLCD Native is an unsigned byte see
         * point (1) of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_StartAcquisition(
                int ObjectToScan,
                int OptionMask,
                GBMSAPI_JAVA_AcquisitionEventsManagerCallbackInterface AcquisitionEventsManagerCallbackPtr,
                Pointer AcquisitionEventsManagerParameters,
                int DisplayOptionMask,
                byte ContrastLimitToDisplayOnLCD,
                byte CompletenessLimitToDisplayOnLCD);

        /**
         *
         * @return @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_StopAcquisition();

        /**
         * Ver 2500: addded GBMSAPI_ROLL_StopPreview(...) function
         *
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_ROLL_StopPreview();

        /**
         *
         * @param ClippingRegionWidth Native is an unsigned int32 see point (1)
         * of ReadME.txt file
         * @param ClippingRegionHeight Native is an unsigned int32 see point (1)
         * of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_SetClippingRegionSize(
                int ClippingRegionWidth,
                int ClippingRegionHeight);

        /**
         *
         * @param Blink Native is a boolean see point (3) of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_VUI_LED_BlinkDuringAcquisition(
                int Blink);

        /**
         *
         * @param Timeout Native is an unsigned int32 see point (1) of
         * ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_ROLL_SetPreviewTimeout(
                int Timeout);

        /**
         *
         * @param ArtefactCleaningDepth Native is an unsigned byte see point (1)
         * of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_ROLL_SetArtefactCleaningDepth(
                byte ArtefactCleaningDepth //see point (1) of ReadME.txt file
                );

        /**
         *
         * @param AcquisitionPhase
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_GetAutoCapturePhase(
                IntByReference AcquisitionPhase);

        /**
         *
         * @param Blocking Native is a boolean see point (3) of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_SetAutoCaptureBlocking(
                int Blocking);

        /**
         *
         * @param Contrast Native is a pointer to an unsigned byte see point (1)
         * of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_GetFingerprintContrast(
                ByteByReference Contrast);

        /**
         *
         * @param FingerprintSize Native is a pointer to an unsigned int32 see
         * point (1) of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_GetFingerprintSize(
                IntByReference FingerprintSize);

        /**
         *
         * @param LowerHalfPalmCompleteness Native is a pointer to an unsigned
         * byte see point (1) of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_GetLowerHalfPalmCompleteness(
                ByteByReference LowerHalfPalmCompleteness);

        /**
         *
         * @param ClippingRegionPosX
         * @param ClippingRegionPosY
         * @param ClippingRegionSizeX Native is a pointer to an unsigned int32
         * see point (1) of ReadME.txt file
         * @param ClippingRegionSizeY Native is a pointer to an unsigned int32
         * see point (1) of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_GetClippingRegionPosition(
                IntByReference ClippingRegionPosX,
                IntByReference ClippingRegionPosY,
                IntByReference ClippingRegionSizeX,
                IntByReference ClippingRegionSizeY);

        /**
         *
         * @param FrameToFinalize
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_ImageFinalization(
                Pointer FrameToFinalize);

        /**
         *
         * @param RolledArtefactSize Native is a pointer to an unsigned int32
         * see point (1) of ReadME.txt file
         * @param MarkerFrame Native is a pointer to buffer (byte **) see point
         * (1) of ReadME.txt file
         * @param NotWipedArtefactFrame Native is a pointer to buffer (byte **)
         * see point (1) of ReadME.txt file
         * @param CompositeFingerprintSize Native is a pointer to an unsigned
         * int32 see point (1) of ReadME.txt file
         * @param CompositeFingerprintContrast Native is a pointer to an
         * unsigned byte see point (1) of ReadME.txt file
         * @param FlatFingerprintSize Native is a pointer to an unsigned int32
         * see point (1) of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_ROLL_GetCompositeImageInfo(
                IntByReference RolledArtefactSize,
                PointerByReference MarkerFrame,
                PointerByReference NotWipedArtefactFrame,
                IntByReference CompositeFingerprintSize,
                ByteByReference CompositeFingerprintContrast,
                IntByReference FlatFingerprintSize);

        /**
         *
         * @param AcquiredFrames Native is a pointer to an unsigned int32 see
         * point (1) of ReadME.txt file
         * @param LostFrames Native is a pointer to an unsigned int32 see point
         * (1) of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_GetFrameStatistic(
                IntByReference AcquiredFrames,
                IntByReference LostFrames);

        /**
         * Ver 2700
         *
         * @param UserDataSize Native is a pointer to a signed int32
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_GetUserDataSize(IntByReference UserDataSize);

        /**
         * Ver 2700
         *
         * @param Address
         * @param Size max value should be (UserDataSize - Address), where
         * UserDataSize is the value got by using the
         * @see GBMSAPI_JAVA_DLL_WRAPPER.GBMSAPI_GetUserDataSize()
         * @param Data should be at least as long as Size
         * @return
         */
        int GBMSAPI_ReadUserData(
                int Address,
                int Size,
                byte[] Data);

        /**
         * Ver 2700
         *
         * @param Address
         * @param Size max value should be (UserDataSize - Address), where
         * UserDataSize is the value got by using the
         * @see GBMSAPI_JAVA_DLL_WRAPPER.GBMSAPI_GetUserDataSize()
         * @param Data should be at least as long as Size
         * @return
         */
        int GBMSAPI_WriteUserData(
                int Address,
                int Size,
                byte[] Data);

        /**
         *
         * @param FlatScanArea Native is a boolean see point (3) of ReadME.txt
         * file
         * @param CalibrationImage
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_SetCalibrationImage(
                int FlatScanArea,
                Pointer CalibrationImage);

        /**
         *
         * @param FlatScanArea Native is a boolean see point (3) of ReadME.txt
         * file
         * @param CalibrationImage
         * @param CalibrationDiagnostic Native is a pointer to an unsigned int32
         * see point (1) of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_GetCalibrationImage(
                int FlatScanArea, // see note (3)
                Pointer CalibrationImage,
                IntByReference CalibrationDiagnostic //see point (1) of ReadME.txt file
                );

        /**
         *
         * @param VersionField1 Native is a pointer to an unsigned byte see
         * point (1) of ReadME.txt file
         * @param VersionField2 Native is a pointer to an unsigned byte see
         * point (1) of ReadME.txt file
         * @param VersionField3 Native is a pointer to an unsigned byte see
         * point (1) of ReadME.txt file
         * @param VersionField4 Native is a pointer to an unsigned byte see
         * point (1) of ReadME.txt file
         * @param LowLevelDllName Native is a pointer to a String (char * null
         * terminated) see point (2) of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_GetUnderlyingLibraryDllVersion(
                ByteByReference VersionField1,
                ByteByReference VersionField2,
                ByteByReference VersionField3,
                ByteByReference VersionField4,
                byte[] LowLevelDllName);

        /**
         * Ver 2700
         *
         * @param NameAndVersion Native is a pointer to a unicode String
         * (wchar_t * null terminated) see point (2) of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_GetDeviceNameAndVersion(
                char[] NameAndVersion);

        /**
         *
         * @param USBErrorCode Native is a pointer to an unsigned int32 see
         * point (1) of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_GetUSBErrorCode(
                IntByReference USBErrorCode);

        /**
         * Ver 2700
         *
         * @param Counter Native is a pointer to an unsigned int32 see point (1)
         * of ReadME.txt file
         * @param ProductionDate Native is a pointer to an unsigned int32 see
         * point (1) of ReadME.txt file; it is the date which statistics
         * collection starts from, in seconds from Jan 1th, 1970. It's not
         * resettable.
         * @return
         */
        int GBMSAPI_GetScannerStatistics(
                IntByReference Counter,
                IntByReference ProductionDate);

        /**
         *
         * @param Tone Native is an unsigned byte see point (1) of ReadME.txt
         * file
         * @param Duration Native is an unsigned byte see point (1) of
         * ReadME.txt file
         * @param Iterations Native is an unsigned byte see point (1) of
         * ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_Sound(
                byte Tone,
                byte Duration,
                byte Iterations);

        /**
         *
         * @param IndicatorMask Native is an unsigned int32 see point (1) of
         * ReadME.txt file
         * @param Color
         * @param Blink Native is a boolean see point (3) of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_SetFingerIndicatorVUIState(
                int IndicatorMask,
                int Color,
                int Blink);

        /**
         *
         * @param PedalState Native is a pointer to an unsigned byte see point
         * (1) of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_CheckPedalState(
                ByteByReference PedalState);

        /**
         * VER 2.8.0.0
         *
         * @param ISO639Lang
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_VUI_LCD_SetLanguage(
                String ISO639Lang);

        /**
         * VER 2.8.0.0
         *
         * @param CompletenessIntermediateLimit Native is a pointer to an
         * unsigned int see point (1) of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_VUI_LCD_GetLcdFeatures(
                IntByReference CompletenessIntermediateLimit);

        /**
         *
         * @return @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_VUI_LCD_SetLogoScreen();

        /**
         *
         * @param ObjToScan Native is an unsigned int32 see point (1) of
         * ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_VUI_LCD_SetScannedObject(
                int ObjToScan);

        /**
         *
         * @param MessageToSet Native is an unsigned byte see point (1) of
         * ReadME.txt file
         * @param MessageArea Native is an unsigned byte see point (1) of
         * ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_VUI_LCD_SetPreloadedMessageOnStopScreen(
                byte MessageToSet,
                byte MessageArea);

        /**
         *
         * @param MessageToSet
         * @param MessageToSetType Native is an unsigned byte see point (1) of
         * ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_VUI_LCD_SetCustomerMessageOnStopScreen(
                String MessageToSet,
                byte MessageToSetType);

        /**
         *
         * @return @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_VUI_LCD_EnableOKButtonOnStopScreen();

        /**
         *
         * @param Quality Native is an unsigned byte see point (1) of ReadME.txt
         * file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_VUI_LCD_SetQualityOnStopScreen(
                byte Quality);

        /**
         *
         * @param Artefact
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_VUI_LCD_SetArtefactOnStopScreen(
                int Artefact);

        /**
         *
         * @param QualityLimit Native is an unsigned byte see point (1) of
         * ReadME.txt file
         * @param Direction Native is an unsigned byte see point (1) of
         * ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_VUI_LCD_SetQualityLimitOnStopScreen(
                byte QualityLimit,
                byte Direction);

        /**
         *
         * @param ArtefactLimit
         * @param Direction Native is an unsigned byte see point (1) of
         * ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_VUI_LCD_SetArtefactLimitOnStopScreen(
                int ArtefactLimit,
                byte Direction);

        /**
         *
         * @param Seg1 Native is an unsigned byte see point (1) of ReadME.txt
         * file
         * @param Seg2 Native is an unsigned byte see point (1) of ReadME.txt
         * file
         * @param Seg3 Native is an unsigned byte see point (1) of ReadME.txt
         * file
         * @param Seg4 Native is an unsigned byte see point (1) of ReadME.txt
         * file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_VUI_LCD_SetSegmentationOnStopScreen(
                byte Seg1,
                byte Seg2,
                byte Seg3,
                byte Seg4);

        /**
         *
         * @return @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_VUI_LCD_EnableStartButtonOnLogoScreen();

        /**
         *
         * @param PressedButton Native is a pointer to an unsigned byte see
         * point (1) of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_VUI_LCD_GetPressedButton(
                ByteByReference PressedButton);

        /**
         * VER 2.8.0.0
         *
         * @param CompletenessIntermediateLimit Native is an unsigned byte see
         * point (1) of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_VUI_LCD_SetCompletenessIntermediateLimit(
                byte CompletenessIntermediateLimit);

        /**
         * VER 2.8.0.0
         *
         * @param ContrastIntermediateLimit Native is an unsigned byte see point
         * (1) of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_VUI_LCD_SetContrastIntermediateLimit(
                byte ContrastIntermediateLimit);

        /**
         *
         * @param ContrastValue Native is an unsigned byte see point (1) of
         * ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_VUI_LCD_SetContrastValueOnAcquisitionScreen(
                byte ContrastValue);

        /**
         *
         * @param CompletenessValue Native is an unsigned byte see point (1) of
         * ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_VUI_LCD_SetCompletenessValueOnAcquisitionScreen(
                byte CompletenessValue);

        /**
         *
         * @param ContrastValue Native is an unsigned byte see point (1) of
         * ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_VUI_LCD_SetContrastValueOnStopScreen(
                byte ContrastValue);

        /**
         *
         * @param CompletenessValue Native is an unsigned byte see point (1) of
         * ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_VUI_LCD_SetCompletenessValueOnStopScreen(
                byte CompletenessValue);

        /**
         *
         * @param ContrastLimit Native is an unsigned byte see point (1) of
         * ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_VUI_LCD_SetContrastLimitOnStopScreen(
                byte ContrastLimit);

        /**
         *
         * @param CompletenessLimit Native is an unsigned byte see point (1) of
         * ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_VUI_LCD_SetCompletenessLimitOnStopScreen(
                byte CompletenessLimit);

        /**
         * VER 2.8.0.0
         *
         * @param QualityIntermediateLimit Native is an unsigned byte see point
         * (1) of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_VUI_LCD_SetQualityIntermediateLimitOnStopScreen(
                byte QualityIntermediateLimit);

        /**
         * VER 2.8.0.0
         *
         * @param ArtefactIntermediateLimit Native is an unsigned int see point
         * (1) of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_VUI_LCD_SetArtefactIntermediateLimitOnStopScreen(
                int ArtefactIntermediateLimit);

        /**
         * VER 2.8.0.0
         *
         * @param ContrastIntermediateLimit Native is an unsigned byte see point
         * (1) of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         * @return
         */
        int GBMSAPI_VUI_LCD_SetContrastIntermediateLimitOnStopScreen(
                byte ContrastIntermediateLimit);

        /**
         * VER 2.8.0.0
         *
         * @param CompletenessIntermediateLimit Native is an unsigned byte see
         * point (1) of ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         * @return
         */
        int GBMSAPI_VUI_LCD_SetCompletenessIntermediateLimitOnStopScreen(
                byte CompletenessIntermediateLimit);

        /**
         *
         * @param Input1000DPIFrame
         * @param Output500DPIFrame
         * @param InputSizeX Native is an unsigned int32 see point (1) of
         * ReadME.txt file
         * @param InputSizeY Native is an unsigned int32 see point (1) of
         * ReadME.txt file
         * @return
         * @see
         * GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes
         */
        int GBMSAPI_ConvertImageFrom1000to500DPI(
                Pointer Input1000DPIFrame,
                Pointer Output500DPIFrame,
                int InputSizeX,
                int InputSizeY);
    }
}