// GBMSGUI.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include <vcclr.h>
#include "GBMSGUI.h"

using namespace System;
using namespace System::Runtime::InteropServices;
using namespace System::Globalization;
using namespace GBMSGUI_NET;

//
static GBMSGUI_AfterStartFuncPtr mAfterStartFunc = NULL;
static void *mAfterStartParam = NULL;

// trick for having global managed variable
ref class GlobalObjects{
public:
	// instance of GBMSGUI class
	static GBMSGUI ^MyGUI = gcnew GBMSGUI();
	static GBMSGUI::AfterStartCallback ^AfterStartCallback = gcnew GBMSGUI::AfterStartCallback(AfterStartFunc);
	static bool AfterStartFunc(IntPtr Param)
	{
		if (mAfterStartFunc)
			// call user callback
			return mAfterStartFunc(mAfterStartParam);

		return true;
	}
};


#ifdef _MANAGED
#pragma managed(push, off)
#endif

BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		break;
	}
    return TRUE;
}

#ifdef _MANAGED
#pragma managed(pop)
#endif

GBMSGUI_API int __stdcall GBMSGUI_SetLanguage(const char *CultureName)
{
	CultureInfo ^culture = CultureInfo::CreateSpecificCulture(gcnew String(CultureName));
	return GlobalObjects::MyGUI->SetLanguage(culture);
}

GBMSGUI_API void __stdcall GBMSGUI_GetVersion(int *Major, int *Minor, int *Build, int *Revision)
{
	Int32 mMajor, mMinor, mBuild, mRevision;
	int ret;

	GlobalObjects::MyGUI->GetVersion(mMajor, mMinor, mBuild, mRevision);

	*Major = mMajor;
	*Minor = mMinor;
	*Build = mBuild;
	*Revision = mRevision;
}

GBMSGUI_API int __stdcall GBMSGUI_SetWindowSizeAndPosition(int Left, int Top, int Width, int Height, bool Maximized)
{
	return GlobalObjects::MyGUI->SetWindowSizeAndPosition(Left, Top, Width, Height, Maximized);
}

GBMSGUI_API int __stdcall GBMSGUI_GetWindowSizeAndPosition(int *Left, int *Top, int *Width, int *Height, bool *Maximized)
{
	Int32 mLeft, mTop, mWidth, mHeight;
	Boolean mMaximized;
	int ret;

	ret = GlobalObjects::MyGUI->GetWindowSizeAndPosition(mLeft, mTop, mWidth, mHeight, mMaximized);

	*Left = mLeft;
	*Top = mTop;
	*Width = mWidth;
	*Height = mHeight;
	*Maximized = mMaximized;
	return ret;
}

GBMSGUI_API int __stdcall GBMSGUI_SetArtefactsThresholds(int Threshold1, int Threshold2)
{
	return GlobalObjects::MyGUI->SetArtefactsThresholds(Threshold1, Threshold2);
}

GBMSGUI_API int __stdcall GBMSGUI_SetQualityAlgorithm(int AlgorithmID)
{
	return GlobalObjects::MyGUI->SetQualityAlgorithm(AlgorithmID);
}

GBMSGUI_API int __stdcall GBMSGUI_SetPatternValidityThreshold(int Threshold)
{
	return GlobalObjects::MyGUI->SetPatternValidityThreshold(Threshold);
}

GBMSGUI_API int __stdcall GBMSGUI_SetPatternCompletenessThreshold(int Threshold)
{
	return GlobalObjects::MyGUI->SetPatternCompletenessThreshold(Threshold);
}

GBMSGUI_API int __stdcall GBMSGUI_SetLowerPalmCompletenessThresholds(int Threshold1, int Threshold2)
{
	return GlobalObjects::MyGUI->SetLowerPalmCompletenessThresholds(Threshold1, Threshold2);
}

GBMSGUI_API int __stdcall GBMSGUI_SetInclinationThreshold(int Threshold)
{
	return GlobalObjects::MyGUI->SetInclinationThreshold(Threshold);
}

GBMSGUI_API int __stdcall GBMSGUI_SetBlockAutoCaptureMask(unsigned int Mask)
{
	return GlobalObjects::MyGUI->SetBlockAutoCaptureMask(Mask);
}

GBMSGUI_API int __stdcall GBMSGUI_SetBlockAutoCaptureContrast(bool Flag)
{
	return GlobalObjects::MyGUI->SetBlockAutoCaptureContrast(Flag);
}

GBMSGUI_API int __stdcall GBMSGUI_SetImageSize(unsigned int ScannedObjectID, unsigned int Width, unsigned int Height)
{
	return GlobalObjects::MyGUI->SetImageSize(ScannedObjectID, Width, Height);
}

GBMSGUI_API int __stdcall GBMSGUI_SetContrastThresholds(unsigned int ScannedObjectID, int Threshold1, int Threshold2)
{
	return GlobalObjects::MyGUI->SetContrastThresholds(ScannedObjectID, Threshold1, Threshold2);
}

GBMSGUI_API int __stdcall GBMSGUI_SetQualityThresholds(unsigned int ScannedObjectID, int Threshold1, int Threshold2)
{
	return GlobalObjects::MyGUI->SetQualityThresholds(ScannedObjectID, Threshold1, Threshold2);
}

GBMSGUI_API int __stdcall GBMSGUI_SetSegmentImageSize(unsigned int ScannedObjectID, int Index, unsigned int Width, unsigned int Height)
{
	return GlobalObjects::MyGUI->SetSegmentImageSize(ScannedObjectID, Index, Width, Height);
}

GBMSGUI_API int __stdcall GBMSGUI_SetSegmentQualityThresholds(unsigned int ScannedObjectID, int Index, int Threshold1, int Threshold2)
{
	return GlobalObjects::MyGUI->SetSegmentQualityThresholds(ScannedObjectID, Index, Threshold1, Threshold2);
}

GBMSGUI_API int __stdcall GBMSGUI_SetSegmentUnavailabilityReason(unsigned int ScannedObjectID, int Index, int Reason)
{
	return GlobalObjects::MyGUI->SetSegmentUnavailabilityReason(ScannedObjectID, Index, Reason);
}

GBMSGUI_API int __stdcall GBMSGUI_SetIgnoreDiagnosticMask(unsigned int Mask)
{
	return GlobalObjects::MyGUI->SetIgnoreDiagnosticMask(Mask);
}

GBMSGUI_API int __stdcall GBMSGUI_SetFlatFingerOnRollArea(bool FlatFingerOnRollArea)
{
	return GlobalObjects::MyGUI->SetFlatFingerOnRollArea(FlatFingerOnRollArea);
}

GBMSGUI_API int __stdcall GBMSGUI_SelectFingerContactEvaluationMode(int Mode)
{
	return GlobalObjects::MyGUI->SelectFingerContactEvaluationMode(Mode);
}

GBMSGUI_API int __stdcall GBMSGUI_StartSession(int AcquisitionMode, wchar_t *PersonID, unsigned int Options)
{
	return GlobalObjects::MyGUI->StartSession(AcquisitionMode, gcnew String(PersonID), Options);
}


GBMSGUI_API void __stdcall GBMSGUI_SetAfterStartCallback(GBMSGUI_AfterStartFuncPtr AfterStartFunc,
    void *AfterStartParam)
{
	mAfterStartFunc = AfterStartFunc;
	mAfterStartParam = AfterStartParam;

	GlobalObjects::MyGUI->SetAfterStartCallback(GlobalObjects::AfterStartCallback, IntPtr(AfterStartParam));
}


GBMSGUI_API int __stdcall GBMSGUI_Acquire(unsigned int ScannedObjectID, unsigned int Options, 
										  unsigned char *ImageBuffer, unsigned long ImageBufferSize, int *ImageSizeX, int *ImageSizeY, int *Dpi)
{
	Int32 mImageSizeX, mImageSizeY, mDpi;
	int ret;

	array<Byte> ^ImageArray;

	if (ImageBuffer != NULL)
		// allocate a new managed byte array
		ImageArray = gcnew array<Byte>(ImageBufferSize);

	ret = GlobalObjects::MyGUI->Acquire(ScannedObjectID, Options, ImageArray, 
		mImageSizeX, mImageSizeY, mDpi);

	if (ret == GBMSGUI_RET_SUCCESS)
	{
		// copy content into the buffer passed to the function
		Marshal::Copy(ImageArray, 0, IntPtr(ImageBuffer), ImageBufferSize);
	}

	*ImageSizeX = mImageSizeX;
	*ImageSizeY = mImageSizeY;
	*Dpi = mDpi;

	return ret;
}

GBMSGUI_API int __stdcall GBMSGUI_GetIAFISQuality(unsigned int ScannedObjectID, int QualityAlgorithm, int *Quality)
{
	Int32 mQuality;
	int ret;

	ret = GlobalObjects::MyGUI->GetIAFISQuality(ScannedObjectID, QualityAlgorithm, mQuality);
	*Quality = mQuality;

	return ret;
}

GBMSGUI_API int __stdcall GBMSGUI_GetUnavailabilityReason(unsigned int ScannedObjectID, int *Reason)
{
	Int32 mReason;
	int ret;

	ret = GlobalObjects::MyGUI->GetUnavailabilityReason(ScannedObjectID, mReason);
	*Reason = mReason;

	return ret;
}

GBMSGUI_API int __stdcall GBMSGUI_GetSegmentationResult(int Index, int QualityAlgorithmID,
            bool *SegmentAvailable, int *Left, int *Top, int *Right, int *Bottom,
            int *UnavailabilityReason, int *FingerprintQuality,
            unsigned char *ImageBuffer, int ImageBufferSize, int *ImageSizeX, int *ImageSizeY, int *Dpi)
{
	Boolean mSegmentAvailable;
	Int32 mLeft, mTop, mRight, mBottom, mUnavailabilityReason, mFingerprintQuality, 
		mImageSizeX, mImageSizeY, mDpi;
	int ret;

	array<Byte> ^ImageArray;
	
	if (ImageBuffer != NULL)
	{
		// allocate a new managed byte array
		ImageArray = gcnew array<Byte>(ImageBufferSize);
	}

	ret = GlobalObjects::MyGUI->GetSegmentationResult(Index, QualityAlgorithmID, mSegmentAvailable,
		mLeft, mTop, mRight, mBottom, mUnavailabilityReason, mFingerprintQuality,
		ImageArray, mImageSizeX, mImageSizeY, mDpi);

	*SegmentAvailable = mSegmentAvailable;
	*Left = mLeft;
	*Top = mTop;
	*Right = mRight;
	*Bottom = mBottom;
	*UnavailabilityReason = mUnavailabilityReason;
	*FingerprintQuality = mFingerprintQuality;
	*ImageSizeX = mImageSizeX;
	*ImageSizeY = mImageSizeY;
	*Dpi = mDpi;

	if ((ImageBuffer != NULL) && mSegmentAvailable)
	{
		// copy content into the buffer passed to the function
		Marshal::Copy(ImageArray, 0, IntPtr(ImageBuffer), ImageBufferSize);
	}

	return ret;
}

GBMSGUI_API int __stdcall GBMSGUI_StopSession()
{
	return GlobalObjects::MyGUI->StopSession();
}

GBMSGUI_API const wchar_t * __stdcall GBMSGUI_GetErrorMessage()
{
	String ^Message = GlobalObjects::MyGUI->GetErrorMessage();

	pin_ptr<const wchar_t> wch = PtrToStringChars(Message);

	return (const wchar_t *)wch;
}

GBMSGUI_API int __stdcall GBMSGUI_GetErrorCode()
{
	return GlobalObjects::MyGUI->GetErrorCode();
}

GBMSGUI_API const wchar_t * __stdcall GBMSGUI_GetMSAPIErrorMessage(wchar_t *FuncName, int ErrCode)
{
	String ^Message = GlobalObjects::MyGUI->GetMSAPIErrorMessage(gcnew String(FuncName), ErrCode);

	pin_ptr<const wchar_t> wch = PtrToStringChars(Message);

	return (const wchar_t *)wch;
}

// UTILITY FUNCTIONS

GBMSGUI_API bool __stdcall GBMSGUI_IsSlap(unsigned int ScanObjID)
{
	return GBMSGUI::IsSlap(ScanObjID);
}

GBMSGUI_API bool __stdcall GBMSGUI_IsRolled(unsigned int ScanObjID)
{
	return GBMSGUI::IsRolled(ScanObjID);
}

GBMSGUI_API bool __stdcall GBMSGUI_IsSingleFinger(unsigned int ScanObjID)
{
	return GBMSGUI::IsSingleFinger(ScanObjID);
}

GBMSGUI_API bool __stdcall GBMSGUI_IsFlatSingleFinger(unsigned int ScanObjID)
{
	return GBMSGUI::IsFlatSingleFinger(ScanObjID);
}

GBMSGUI_API bool __stdcall GBMSGUI_IsPalm(unsigned int ScanObjID)
{
	return GBMSGUI::IsPalm(ScanObjID);
}

GBMSGUI_API bool __stdcall GBMSGUI_IsLowerPalm(unsigned int ScanObjID)
{
	return GBMSGUI::IsLowerPalm(ScanObjID);
}

GBMSGUI_API bool __stdcall GBMSGUI_IsUpperPalm(unsigned int ScanObjID)
{
	return GBMSGUI::IsUpperPalm(ScanObjID);
}

GBMSGUI_API bool __stdcall GBMSGUI_IsWritersPalm(unsigned int ScanObjID)
{
	return GBMSGUI::IsWritersPalm(ScanObjID);
}
