using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace GBMSGUI_NET
{
    public partial class ViewSegmForm : Form
    {
        public Bitmap bmpImage;

        public ViewSegmForm()
        {
            InitializeComponent();
        }

        private void ViewSegmForm_Load(object sender, EventArgs e)
        {
            pboxImage.Image = bmpImage;

            // if possible, make image appear in original dimension
            if ((bmpImage.Width < Screen.PrimaryScreen.WorkingArea.Width) &&
                (bmpImage.Height < Screen.PrimaryScreen.WorkingArea.Height))
            {
                this.Width = bmpImage.Width + this.Width - pboxImage.Width;
                this.Height = bmpImage.Height + this.Height - pboxImage.Height;

                // center the window
                this.Left = (Screen.PrimaryScreen.WorkingArea.Width - this.Width) / 2;
                this.Top = (Screen.PrimaryScreen.WorkingArea.Height - this.Height) / 2;
            }
            else
            {
                // make window full screen
                this.WindowState = FormWindowState.Maximized;
            }
        }
    }
}