#ifndef CLIPRECTITEM_H
#define CLIPRECTITEM_H

#include <QObject>
#include <QtGui>

enum SizeOperations     // size operations for clipping rectangle and bounding boxes
{
    SizeOperationNone,
    SizeOperationRight,
    SizeOperationLeft,
    SizeOperationTop,
    SizeOperationBottom,
    SizeOperationMove
};
enum SizeOptions
{
    AllowResize = 0x01,
    AllowMove = 0x02
};

class QClipRectItem : public QObject, public QGraphicsRectItem
{
    Q_OBJECT
public:
    //explicit QClipRectItem(QObject *parent = 0);
    explicit QClipRectItem(QColor PenColor=Qt::black, int PenWidth=1, Qt::PenStyle PenStyle=Qt::SolidLine);
    ~QClipRectItem();
    void SetSizeOption(SizeOptions SizeOption);
    void SetEnabled(bool Enabled);
    void paint ( QPainter * painter, const QStyleOptionGraphicsItem * option, QWidget * widget = 0 );
    void SetText(QString Value);
    void SetQuality(int Value, QColor Color);
    void SetDiagIcon(QPixmap Icon);

protected:
    QVariant itemChange ( GraphicsItemChange change, const QVariant & value );
    void hoverMoveEvent(QGraphicsSceneHoverEvent *event);
    void mousePressEvent ( QGraphicsSceneMouseEvent * event );
    void mouseMoveEvent ( QGraphicsSceneMouseEvent *event );
    void mouseReleaseEvent ( QGraphicsSceneMouseEvent *event );
private:
    bool resizing;
    bool mEnabled;
    SizeOperations mSizeOperation;
    SizeOptions mSizeOption;
    //QBrush mBrush;
    QPen mPen;
    QString Text;
    int QualityValue;
    QColor QualityColor;
    QPixmap DiagIcon;

signals:
    void Changed();

public slots:

};

#endif // CLIPRECTITEM_H
