#ifdef DSBEEP_EXPORTS
#define DSBEEP_API __declspec(dllexport)
#else
#define DSBEEP_API __declspec(dllimport)
#endif

#ifdef __cplusplus
extern "C"
{
#endif

//----------------------------------------------------------------------------------------------------------
DSBEEP_API bool __stdcall DSInit(unsigned int CoInit, bool ForceDS);
//----------------------------------------------------------------------------------------------------------
// The function initializes COM for using DirectSound, calling CoInitializeEx with the specified CoInit value.
// If not called, it is called automatically the first time DSBeep is called, with the
// default value COINIT_APARTMENTTHREADED (0x02), but this will result in a little delay before the first
// sound emission.
// It is sufficient to call once after dll loading, succcessive calls will return immedialtely.
// If called from a Dll, DO NOT CALL IN DllMain on in phase of dll load.
//----------------------------------------------------------------------------------------------------------
// Return value: 
//   True or false
//----------------------------------------------------------------------------------------------------------
// Parameters:
//	<CoInit>	- value passed to CoInitializeEx, can be COINIT_APARTMENTTHREADED (0x02) or
//				  COINIT_MULTITHREADED (0x00) (defined in objbase.h)
//  <ForceDS>	- set to true to force to always use DirectSound (also in cases when Beep is supported);
//				  by default is set to false
//----------------------------------------------------------------------------------------------------------


//----------------------------------------------------------------------------------------------------------
DSBEEP_API bool __stdcall DSBeep(int Frequency, int Duration);
//----------------------------------------------------------------------------------------------------------
// The function plays a sound of the specified frequency and duration, using Beep API (internal PC speker)
// or DirectSound in Windows versions that does not support Beep (x64 versions and Win7).
//----------------------------------------------------------------------------------------------------------
// Return value: 
//   True or false
//----------------------------------------------------------------------------------------------------------
// Parameters:
//	<Frequency>	- sound frequency, in hertz
//	<Duration>	- sound duration, in milliseconds
//----------------------------------------------------------------------------------------------------------


//----------------------------------------------------------------------------------------------------------
DSBEEP_API void __stdcall DSDeInit();
//----------------------------------------------------------------------------------------------------------
// The function deinitializes COM.
// If called from a Dll, DO NOT CALL IN DllMain on in phase of dll unload.
//----------------------------------------------------------------------------------------------------------
// Return value: 
//   None
//----------------------------------------------------------------------------------------------------------

#ifdef __cplusplus
}
#endif