#ifndef SELECTOBJECTFORM_H
#define SELECTOBJECTFORM_H

#include <QDialog>
#include <QSignalMapper>
#include "ClickableLabel.h"

namespace Ui {
    class SelectObjectForm;
}

class SelectObjectForm : public QDialog
{
    Q_OBJECT

public:
    explicit SelectObjectForm(QWidget *parent = 0);
    ~SelectObjectForm();
	int GetObjectID();

public slots:
    void done(int r);

private slots:
	void OnShapeSelected(QWidget *widget);
	void OnSingleFingerSelected();

private:
    Ui::SelectObjectForm *ui;
    QSignalMapper *ShapeSignalMapper;
    int ObjectID;
    bool RollSupported;
    bool FlatSupported;
    bool Slap4Supported;
    bool TwoThumbsSupported;
    bool Slap2Supported;
    bool LowerPalmSupported;
    bool UpperPalmSupported;
    bool WritersPalmSupported;
    bool TwoIndexesSupported;
	void AddShapeMap(QWidget *widget);
    void FillObjectsList();
	void SetZOrder();
    void SetHints();
    void SetObjectSelection(QLabel *lblShape, bool Selected);
};

#endif // SELECTOBJECTFORM_H
