#ifndef BOZORTH_DLL_H
#define BOZORTH_DLL_H

#ifdef __cplusplus
extern "C"
{
#endif

/*************************************************************************
VERY IMPORTANT: BEFORE INCLUDING THIS FILE, INCLUDE LFS_DLL.H for MINUTIAE
struct definition
**************************************************************************/

#ifdef BOZORTH_COMPILE_DLL
#define BZ_DllExport   __declspec( dllexport )
#else
#define BZ_DllExport
#endif
	/*************************************************************************
	**************************************************************************
	#cat:   boz_direct_call - Calculates the match score between two fingerprints
	#cat:                given their minutiae
	
	   Input:
		  maxminutiae	- max number of minutiae that are to be considered for
						 matching
		  probe			- pointer to the minutiae of the first fingerprint
		  gallery		- pointer to the minutiae of the second fingerprint
		  
	   Output and Return Code:
		  > Zero	- successful completion
		  Negative	- error
	**************************************************************************/
	BZ_DllExport int __stdcall boz_direct_call(int maxminutiae,
		MINUTIAE *probe,
		MINUTIAE *gallery
	);

#ifdef __cplusplus
}
#endif

#endif