/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package test_gban2k_java;

import java.util.logging.Logger;
import java.io.*;

import GBAN2K_JAVA_Defines.GBAN2K_AnsiNistRecordsDefines;
import GBAN2K_JAVA_Defines.GBAN2K_CompressionAlgorithmsDefines;
import GBAN2K_JAVA_Defines.GBAN2K_EFTSType2Defines;
import GBAN2K_JAVA_Defines.GBAN2K_EFTSType4Defines;
import GBAN2K_JAVA_Defines.GBAN2K_ErrorDefines;
import GBAN2K_JAVA_Defines.GBAN2K_FingerPositionsDefines;
import GBAN2K_JAVA_Defines.GBAN2K_ImpressionCodesDefines;
import GBAN2K_JAVA_Defines.GBAN2K_PalmPositionsDefines;
import GBAN2K_JAVA_Defines.GBAN2K_PixelDepthDefines;
import GBAN2K_JAVA_Defines.GBAN2K_VersionDefines;
import com.sun.jna.Library;
import com.sun.jna.Native;
import com.sun.jna.Pointer;
import com.sun.jna.ptr.IntByReference;
import com.sun.jna.ptr.ByteByReference;
import com.sun.jna.ptr.PointerByReference;
import com.sun.jna.ptr.DoubleByReference;
import com.sun.jna.ptr.FloatByReference;
import com.sun.jna.Memory;
import com.sun.jna.Structure;

import java.io.DataInputStream;
import java.io.FileInputStream;
import java.nio.ByteBuffer;
import java.util.Arrays;

import GBAN2K_JAVA_LibraryFunctions.GBAN2K_DllWrapper;
import GBAN2K_JAVA_Structures.GBAN2K_AnsiNistStructure;
import GBAN2K_JAVA_Structures.GBAN2K_FingerAmputationStructure;
import GBAN2K_JAVA_Structures.GBAN2K_FingerAmputionsList;
import GBAN2K_JAVA_Structures.GBAN2K_AlternateQualityList;
import GBAN2K_JAVA_Structures.GBAN2K_AlternateQualityStructure;
import GBAN2K_JAVA_Structures.GBAN2K_FieldStructure;
import GBAN2K_JAVA_Structures.GBAN2K_FingerAmputationStructure;
import GBAN2K_JAVA_Structures.GBAN2K_FingerQualityStructure;

import GBAN2K_JAVA_Structures.GBAN2K_FingerSegmentStructure;
import GBAN2K_JAVA_Structures.GBAN2K_FourFingersBoundsStructure;
import GBAN2K_JAVA_Structures.GBAN2K_ItemStructure;
import GBAN2K_JAVA_Structures.GBAN2K_PalmQualityList;
import GBAN2K_JAVA_Structures.GBAN2K_PalmQualityStructure;
import GBAN2K_JAVA_Structures.GBAN2K_RecordListStructure;
import GBAN2K_JAVA_Structures.GBAN2K_RecordStructure;
import GBAN2K_JAVA_Structures.GBAN2K_SubfieldStructure;
import GBAN2K_JAVA_Structures.GBAN2K_FourFingersQualitiesStructure;

/**
 *
 * @author andrea
 */
public class Test_GBAN2K_Java {
    
    private static void WriteAllBytes(String fileName, byte[] BufferToSave) {
		FileOutputStream fos = null;
		DataOutputStream ds = null;
		try {
			fos = new FileOutputStream(fileName);
			ds = new DataOutputStream(fos);
			ds.write(BufferToSave);
		} catch (Exception e) {
			System.out.println("Error in SaveOnFile");
		} finally {
			try {
				ds.close();
			} catch (IOException ex) {
				System.out.println("Error in closing ds");
			}
			try {
				fos.close();
			} catch (IOException ex) {
				System.out.println("Error in closing fos");
			}
		}
	}

	private static byte[] loadFile(File file) {
		FileInputStream fin = null;

		byte[] fileContent = null;
		try {
			fin = new FileInputStream(file);
			fileContent = new byte[(int) file.length()];
			fin.read(fileContent);



		} catch (IOException ex) {
			System.out.println("Error in getting file: ");
		} finally {
			try {
				fin.close();


			} catch (IOException ex) {
				System.out.println("Error in closing file: ");
			}

		}
		return fileContent;
	}

	private static byte[] ReadAllBytes(String fileName) {
		File file = new File(fileName);
		return loadFile(file);
	}

    public static boolean PrintErrorMessage(int RetVal, String FunctionName) {
        System.out.println(FunctionName + " returned: " + RetVal);
        if (RetVal != GBAN2K_ErrorDefines.AN2K_DLL_NO_ERROR) {
            return false;
        }
        return true;
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        /////////////////////////////////////////
        // CREATE ANSI NIST BUFFER
        /////////////////////////////////////////
        System.out.println("//////////////////////////////////////////");
        System.out.println("**** CREATE ANSI NIST BUFFER *************");
        System.out.println("//////////////////////////////////////////");
        System.out.println();
        Pointer pAnsiNist = new Memory(Pointer.SIZE);
        int iVersion = GBAN2K_VersionDefines.VERSION_0400, iPriority = 1;
        String StrDestinationAgency = "DestAgc",
                StrOriginatingAgency = "GreenBit",
                StrTransactionControlID = "123456789",
                StrTransactionControlReference = "987654321",
                StrDomainNameID = "Italy",
                strToT = "MyType";
        float fNominalScanningResolution = (float) 19.56,
                fNominalTransmitResolution = (float) 8.28;
        int RetVal = GBAN2K_DllWrapper.GBAN2K_Library.INSTANCE.Create_ANSI_NIST(
                pAnsiNist,
                iVersion, strToT, iPriority,
                StrDestinationAgency,
                StrOriginatingAgency,
                StrTransactionControlID,
                StrTransactionControlReference,
                fNominalScanningResolution,
                fNominalTransmitResolution,
                StrDomainNameID);
        if (PrintErrorMessage(RetVal, "Create_ANSI_NIST") != true) {
            System.out.println("FAILURE, exit");
            return;
        }
        System.out.println();
        /////////////////////////////////////////
        // READ ANSI NIST BUFFER
        /////////////////////////////////////////
        System.out.println("//////////////////////////////////////////");
        System.out.println("**** READ ANSI NIST BUFFER *************");
        System.out.println("//////////////////////////////////////////");
        System.out.println();

        GBAN2K_AnsiNistStructure MyAnsiNist = new GBAN2K_AnsiNistStructure(pAnsiNist.getPointer(0));
        System.out.println("MyAnsiNist.alloc_records: " + MyAnsiNist.alloc_records);
        System.out.println("MyAnsiNist.num_bytes: " + MyAnsiNist.num_bytes);
        System.out.println("MyAnsiNist.num_records: " + MyAnsiNist.num_records);

        Pointer pRec1 = (MyAnsiNist.records.getPointerArray(0, MyAnsiNist.alloc_records))[0];
        IntByReference piVersion = new IntByReference(),
                piPriority = new IntByReference(),
                piDestAgcLen = new IntByReference(),
                piOrigAgcLen = new IntByReference(),
                piTransContLen = new IntByReference(),
                piTransContRefLen = new IntByReference(),
                piDomainLen = new IntByReference();
        FloatByReference pfNominalScanRes = new FloatByReference(),
                pfNominalTxRes = new FloatByReference();

        byte[] baTransType = new byte[12];
        Pointer pStrDestAgc = new Memory(Pointer.SIZE),
                pStrOrigAgc = new Memory(Pointer.SIZE),
                pStrTransCont = new Memory(Pointer.SIZE),
                pStrTransContRef = new Memory(Pointer.SIZE),
                pStrDomain = new Memory(Pointer.SIZE);
        RetVal = GBAN2K_DllWrapper.GBAN2K_Library.INSTANCE.GetEFTSType1_Info(
                pRec1,
                piVersion,
                baTransType,
                piPriority,
                pStrDestAgc, piDestAgcLen,
                pStrOrigAgc, piOrigAgcLen,
                pStrTransCont, piTransContLen,
                pStrTransContRef, piTransContRefLen,
                pfNominalScanRes, pfNominalTxRes,
                pStrDomain, piDomainLen);
        if (PrintErrorMessage(RetVal, "GetEFTSType1_Info") != true) {
            System.out.println("FAILURE, exit");
            return;
        }

        System.out.println("Version: " + piVersion.getValue());
        System.out.println("Priority: " + piPriority.getValue());
        System.out.println("piDestAgc: "
                + new String((pStrDestAgc.getPointer(0).getByteArray(0, piDestAgcLen.getValue()))));
        System.out.println("piOrigAgc: "
                + new String((pStrOrigAgc.getPointer(0).getByteArray(0, piOrigAgcLen.getValue()))));
        System.out.println("piTransCont: "
                + new String((pStrTransCont.getPointer(0).getByteArray(0, piTransContLen.getValue()))));
        System.out.println("piTransContRef: "
                + new String((pStrTransContRef.getPointer(0).getByteArray(0, piTransContRefLen.getValue()))));
        System.out.println("piDomain: "
                + new String((pStrDomain.getPointer(0).getByteArray(0, piDomainLen.getValue()))));
        System.out.println("pfNominalScanRes: " + pfNominalScanRes.getValue());
        System.out.println("pfNominalTxRes: " + pfNominalTxRes.getValue());
        System.out.println("TransType: " + new String(baTransType));
        System.out.println();
        /////////////////////////////////////////
        // UPDATE TYPE-1
        /////////////////////////////////////////
        System.out.println("//////////////////////////////////////////");
        System.out.println("**** UPDATE TYPE-1 RECORD ****************");
        System.out.println("//////////////////////////////////////////");
        System.out.println();

        RetVal = GBAN2K_DllWrapper.GBAN2K_Library.INSTANCE.UpdateETFStype_1(pRec1,
                (float) 15.28,
                (float) 5.36);
        if (PrintErrorMessage(RetVal, "UpdateETFStype_1") != true) {
            System.out.println("FAILURE, exit");
            return;
        }


        /*****
         * Get info as a test of the
         * succesful update
         */
        RetVal = GBAN2K_DllWrapper.GBAN2K_Library.INSTANCE.GetEFTSType1_Info(
                pRec1,
                piVersion,
                baTransType,
                piPriority,
                pStrDestAgc, piDestAgcLen,
                pStrOrigAgc, piOrigAgcLen,
                pStrTransCont, piTransContLen,
                pStrTransContRef, piTransContRefLen,
                pfNominalScanRes, pfNominalTxRes,
                pStrDomain, piDomainLen);
        if (PrintErrorMessage(RetVal, "GetEFTSType1_Info") != true) {
            System.out.println("FAILURE, exit");
            return;
        }

        System.out.println("Version: " + piVersion.getValue());
        System.out.println("Priority: " + piPriority.getValue());
        System.out.println("piDestAgc: "
                + new String((pStrDestAgc.getPointer(0).getByteArray(0, piDestAgcLen.getValue()))));
        System.out.println("piOrigAgc: "
                + new String((pStrOrigAgc.getPointer(0).getByteArray(0, piOrigAgcLen.getValue()))));
        System.out.println("piTransCont: "
                + new String((pStrTransCont.getPointer(0).getByteArray(0, piTransContLen.getValue()))));
        System.out.println("piTransContRef: "
                + new String((pStrTransContRef.getPointer(0).getByteArray(0, piTransContRefLen.getValue()))));
        System.out.println("piDomain: "
                + new String((pStrDomain.getPointer(0).getByteArray(0, piDomainLen.getValue()))));
        System.out.println("pfNominalScanRes: " + pfNominalScanRes.getValue());
        System.out.println("pfNominalTxRes: " + pfNominalTxRes.getValue());
        System.out.println("TransType: " + new String(baTransType));
        System.out.println();
        /////////////////////////////////////////
        // CREATE TYPE-14 Record
        // with a very simple image (6 bytes,
        // 2x3)
        /////////////////////////////////////////
        System.out.println("//////////////////////////////////////////");
        System.out.println("**** CREATE TYPE-14 Record ****************");
        System.out.println("//////////////////////////////////////////");
        System.out.println();

        Pointer pRec14 = new Memory(Pointer.SIZE);

        /***************************
         * create a fake 2x3 image
         */
        byte[] FingerprintImage = new byte[6];
        for (int i = 0; i < 6; i++) {
            FingerprintImage[i] = (byte) i;
        }
        int FPImageSize = 6;
        int FPImageWidth = 2,
                FPImageHeight = 3,
                FPImagePixelDepth = GBAN2K_PixelDepthDefines.PIXEL_DEPTH_8BPP;
        double ScanResolutionPPMM = 19.26;
        String CompressionType = GBAN2K_CompressionAlgorithmsDefines.COMP_NONE;
        int ImpressionType = GBAN2K_ImpressionCodesDefines.ETFS_14_LIVE_SCAN_PLAN;
        String ImageSource = "Green Bit scan";
        String Comment = "MyComment";
        String FingerPosition = GBAN2K_FingerPositionsDefines.ETFS_14_FGP_LEFT_4_FING;

        /****************************************
         * Create a fake amputation list
         */
        GBAN2K_FingerAmputionsList AmputationList = new GBAN2K_FingerAmputionsList();
        AmputationList.num_fingers = 1;
        AmputationList.fingers = new Memory(Pointer.SIZE);
        GBAN2K_FingerAmputationStructure AmpStruct = new GBAN2K_FingerAmputationStructure();
        AmpStruct.amp_code[0] = (byte) 'X';
        AmpStruct.amp_code[1] = (byte) 'X';
        AmpStruct.amp_code[2] = (byte) 0;
        AmpStruct.fing_id[0] = (byte) '0';
        AmpStruct.fing_id[1] = (byte) '7';
        AmpStruct.fing_id[2] = (byte) 0;

        AmputationList.fingers.setPointer(0, AmpStruct.getPointer());

        RetVal = GBAN2K_DllWrapper.GBAN2K_Library.INSTANCE.image2ETFStype_14(
                pRec14, // RECORD**
                FingerprintImage,
                FPImageSize,
                FPImageWidth,
                FPImageHeight,
                FPImagePixelDepth,
                ScanResolutionPPMM,
                CompressionType,
                ImpressionType,
                ImageSource,
                Comment,
                FingerPosition,
                AmputationList,
                (GBAN2K_FourFingersBoundsStructure) null,
                (GBAN2K_FourFingersQualitiesStructure) null,
                (GBAN2K_AlternateQualityList) null,
                (GBAN2K_AlternateQualityList) null);
        if (PrintErrorMessage(RetVal, "image2ETFStype_14") != true) {
            System.out.println("FAILURE, exit");
            return;
        }

        System.out.println("//////////////////////////////////////////");
        System.out.println("**** READ TYPE-14 RECORD *****************");
        System.out.println("//////////////////////////////////////////");
        System.out.println();

        Pointer rec14 = pRec14.getPointer(0);
        Pointer ImagePtr = new Memory(Pointer.SIZE),
                pamp_list = new Memory(Pointer.SIZE),
                pboundaries = new Memory(Pointer.SIZE),
                pqualities = new Memory(Pointer.SIZE),
                psegqual = new Memory(Pointer.SIZE),
                paltqual = new Memory(Pointer.SIZE);
        IntByReference ImageSize = new IntByReference(),
                w = new IntByReference(),
                h = new IntByReference(),
                PixelDepth = new IntByReference(),
                ImageImpression = new IntByReference();
        DoubleByReference Resolution_ppmm = new DoubleByReference();
        byte[] ImageCompression = new byte[10],
                source_str = new byte[44],
                comment = new byte[136],
                finger_position_list = new byte[18];

        RetVal = GBAN2K_DllWrapper.GBAN2K_Library.INSTANCE.Get_EFTStype14_Info(
                rec14, // RECORD*
                ImagePtr, //byte **
                ImageSize, // allocated memory for image frame (can be different from w x h)
                w,
                h, // image dimensions
                PixelDepth, // bits per pixel
                Resolution_ppmm, // resolution in pixel per mm
                ImageCompression, // image compression: see definitions: pass a char[10]
                ImageImpression, // image impression type (live-scan, roll, etc, see definitions)
                source_str, // string identifying the originating source of the image,
                // pass a char[44]
                comment, // comment, pass a char[136]
                finger_position_list, // list of strings indicating the finger position.
                // See definitions, pass a byte[18]
                // (6 items by 3 chars each)
                pamp_list, // FING_AMP_LIST**: allocated 
                // by the library
                pboundaries, // FOUR_FING_BOUND**
                pqualities, // FOUR_FING_QUALITY**
                psegqual, // ALT_QUAL_LIST**
                paltqual // ALT_QUAL_LIST**
                );
        if (PrintErrorMessage(RetVal, "Get_EFTStype14_Info") != true) {
            System.out.println("FAILURE, exit");
            return;
        }

        // get the image
        byte[] ImgPixels = ImagePtr.getPointer(0).getByteArray(0, ImageSize.getValue());
        for (int i = 0; i < ImageSize.getValue(); i++) {
            System.out.println("\tbyte " + (i + 1) + " of image is " + ImgPixels[i]);
        }
        System.out.println("ImageSize: " + ImageSize.getValue());
        System.out.println("w, h: " + w.getValue() + ", " + h.getValue());
        System.out.println("PixelDepth: " + PixelDepth.getValue());
        System.out.println("Resolution_ppmm: " + Resolution_ppmm.getValue());
        System.out.println("ImageCompression: "
                + new String(ImageCompression));
        System.out.println("ImageImpression: " + ImageImpression.getValue());
        System.out.println("source_str: "
                + new String(source_str));
        System.out.println("comment: "
                + new String(comment));
        // finger position
        int PosInFingPosBuffer = 0;
        for (int i = 0; i < 6; i++) {
            byte[] dummyBuf = Arrays.copyOfRange(
                    finger_position_list, PosInFingPosBuffer, PosInFingPosBuffer + 3);
            String dummyFingPos = new String(dummyBuf);
            System.out.println("\tfinger pos " + (i + 1) + ": " + dummyFingPos);

            PosInFingPosBuffer += 3;
        }
        // amputation list
        if (pamp_list.getPointer(0) != Pointer.NULL) {
            GBAN2K_FingerAmputionsList amp_list = new GBAN2K_FingerAmputionsList(pamp_list.getPointer(0));
            System.out.println("Num of fingers in amputation list: " + amp_list.num_fingers);
            for (int i = 0, offset = 0; i < amp_list.num_fingers; i++, offset += Pointer.SIZE) {
                GBAN2K_FingerAmputationStructure ampfinger = new GBAN2K_FingerAmputationStructure(amp_list.fingers.getPointer(offset));
                System.out.println("\tFingID: " + new String(ampfinger.fing_id) + ", Amp code: " + new String(ampfinger.amp_code));
            }
        }
        System.out.println();

        ////////////////////////////////////////////////////
        // UPDATE TYPE-14 RECORD
        ////////////////////////////////////////////////////
        System.out.println("//////////////////////////////////////////");
        System.out.println("**** UPDATE TYPE-14 RECORD ***************");
        System.out.println("//////////////////////////////////////////");
        System.out.println();
        RetVal = GBAN2K_DllWrapper.GBAN2K_Library.INSTANCE.UpdateETFStype_14(
                rec14, // RECORD*
                FingerprintImage,
                FPImageSize,
                6,
                1,
                20.22,
                null,
                null,
                null,
                null,
                null);
        if (PrintErrorMessage(RetVal, "UpdateETFStype_14") != true) {
            System.out.println("FAILURE, exit");
            return;
        }

        RetVal = GBAN2K_DllWrapper.GBAN2K_Library.INSTANCE.Get_EFTStype14_Info(
                rec14, // RECORD*
                ImagePtr, //byte **
                ImageSize, // allocated memory for image frame (can be different from w x h)
                w,
                h, // image dimensions
                PixelDepth, // bits per pixel
                Resolution_ppmm, // resolution in pixel per mm
                ImageCompression, // image compression: see definitions: pass a char[10]
                ImageImpression, // image impression type (live-scan, roll, etc, see definitions)
                source_str, // string identifying the originating source of the image,
                // pass a char[44]
                comment, // comment, pass a char[136]
                finger_position_list, // list of strings indicating the finger position.
                // See definitions, pass a byte[18]
                // (6 items by 3 chars each)
                pamp_list, // FING_AMP_LIST**: allocated 
                // by the library
                pboundaries, // FOUR_FING_BOUND**
                pqualities, // FOUR_FING_QUALITY**
                psegqual, // ALT_QUAL_LIST**
                paltqual // ALT_QUAL_LIST**
                );
        if (PrintErrorMessage(RetVal, "Get_EFTStype14_Info") != true) {
            System.out.println("FAILURE, exit");
            return;
        }

        // get the image
        ImgPixels = ImagePtr.getPointer(0).getByteArray(0, ImageSize.getValue());
        for (int i = 0; i < ImageSize.getValue(); i++) {
            System.out.println("\tbyte " + (i + 1) + " of image is " + ImgPixels[i]);
        }
        System.out.println("ImageSize: " + ImageSize.getValue());
        System.out.println("w, h: " + w.getValue() + ", " + h.getValue());
        System.out.println("PixelDepth: " + PixelDepth.getValue());
        System.out.println("Resolution_ppmm: " + Resolution_ppmm.getValue());
        System.out.println("ImageCompression: "
                + new String(ImageCompression));
        System.out.println("ImageImpression: " + ImageImpression.getValue());
        System.out.println("source_str: "
                + new String(source_str));
        System.out.println("comment: "
                + new String(comment));
        // finger position
        PosInFingPosBuffer = 0;
        for (int i = 0; i < 6; i++) {
            byte[] dummyBuf = Arrays.copyOfRange(
                    finger_position_list, PosInFingPosBuffer, PosInFingPosBuffer + 3);
            String dummyFingPos = new String(dummyBuf);
            System.out.println("\tfinger pos " + (i + 1) + ": " + dummyFingPos);

            PosInFingPosBuffer += 3;
        }
        // amputation list
        if (pamp_list.getPointer(0) != Pointer.NULL) {
            GBAN2K_FingerAmputionsList amp_list = new GBAN2K_FingerAmputionsList(pamp_list.getPointer(0));
            System.out.println("Num of fingers in amputation list: " + amp_list.num_fingers);
            for (int i = 0, offset = 0; i < amp_list.num_fingers; i++, offset += Pointer.SIZE) {
                GBAN2K_FingerAmputationStructure ampfinger = new GBAN2K_FingerAmputationStructure(amp_list.fingers.getPointer(offset));
                System.out.println("\tFingID: " + new String(ampfinger.fing_id) + ", Amp code: " + new String(ampfinger.amp_code));
            }
        }
        System.out.println();
        /////////////////////////////////////////
        // CREATE TYPE-4 Record
        // with a very simple image (6 bytes,
        // 2x3)
        /////////////////////////////////////////
        System.out.println("//////////////////////////////////////////");
        System.out.println("**** CREATE TYPE-4 Record ****************");
        System.out.println("//////////////////////////////////////////");
        System.out.println();

        Pointer pRec4 = new Memory(Pointer.SIZE);
        ImpressionType = GBAN2K_ImpressionCodesDefines.ETFS_14_LIVE_SCAN_ROLLED;
        int FingerPositionInt = Integer.parseInt(GBAN2K_FingerPositionsDefines.ETFS_14_FGP_LEFT_RING);
        int ScanResolutionID = GBAN2K_EFTSType4Defines.ETFS_TYPE4_MAX_RES_VAL;
        CompressionType = GBAN2K_CompressionAlgorithmsDefines.BIN_COMP_JPEGB;
        for (int i = 0; i < 6; i++) {
            FingerprintImage[i] = (byte) (i + 6);
        }

        RetVal = GBAN2K_DllWrapper.GBAN2K_Library.INSTANCE.image2ETFStype_4(
                pRec4, // RECORD**
                FingerprintImage,
                FPImageSize,
                ImpressionType,
                FingerPositionInt,
                ScanResolutionID,
                FPImageWidth,
                FPImageHeight,
                CompressionType);
        if (PrintErrorMessage(RetVal, "image2ETFStype_4") != true) {
            System.out.println("FAILURE, exit");
            return;
        }


        System.out.println("//////////////////////////////////////////");
        System.out.println("**** READ TYPE-4 RECORD ******************");
        System.out.println("//////////////////////////////////////////");
        System.out.println();

        Pointer rec4 = pRec4.getPointer(0);
        int[] finger_position = new int[6];
        IntByReference ImageResolution = new IntByReference();
        ImageCompression = new byte[10];
        RetVal = GBAN2K_DllWrapper.GBAN2K_Library.INSTANCE.Get_EFTStype4_Info(
                rec4,// RECORD*
                ImagePtr, // unsigned char**
                ImageSize,
                ImageImpression, // image impression type (live-scan, roll, etc, see definitions)
                finger_position, // pass an int[6]
                ImageResolution, // the scan resolution of the fingerprint image. See definitions
                w,
                h, // image dimensions
                ImageCompression // image compression: see definitions: pass a char[10]
                );
        if (PrintErrorMessage(RetVal, "Get_EFTStype4_Info") != true) {
            System.out.println("FAILURE, exit");
            return;
        }

        // get the image
        ImgPixels = ImagePtr.getPointer(0).getByteArray(0, w.getValue() * h.getValue());
        for (int i = 0; i < w.getValue() * h.getValue(); i++) {
            System.out.println("\tbyte " + (i + 1) + " of image is " + ImgPixels[i]);
        }
        for (int i = 0; i < 6; i++) {
            System.out.println("\tfinger_position at position " + (i + 1) + " is " + finger_position[i]);
        }
        System.out.println("w, h: " + w.getValue() + ", " + h.getValue());
        System.out.println("ImageImpression: " + ImageImpression.getValue());
        System.out.println("ImageResolution: " + ImageResolution.getValue());
        System.out.println("ImageCompression: "
                + new String(ImageCompression));
        System.out.println();


        System.out.println("//////////////////////////////////////////");
        System.out.println("**** UPDATE TYPE-4 RECORD ****************");
        System.out.println("//////////////////////////////////////////");
        System.out.println();

        for (int i = 0; i < 6; i++) {
            FingerprintImage[i] = (byte) (i + 12);
        }
        ScanResolutionID = GBAN2K_EFTSType4Defines.ETFS_TYPE4_MIN_RES_VAL;
        RetVal = GBAN2K_DllWrapper.GBAN2K_Library.INSTANCE.UpdateETFStype_4(
                rec4,// RECORD* 
                FingerprintImage,
                FPImageSize,
                ScanResolutionID,
                3,
                2);
        if (PrintErrorMessage(RetVal, "UpdateETFStype_4") != true) {
            System.out.println("FAILURE, exit");
            return;
        }


        System.out.println("//////////////////////////////////////////");
        System.out.println("**** READ TYPE-4 RECORD ******************");
        System.out.println("//////////////////////////////////////////");
        System.out.println();

        RetVal = GBAN2K_DllWrapper.GBAN2K_Library.INSTANCE.Get_EFTStype4_Info(
                rec4,// RECORD*
                ImagePtr, // unsigned char**
                ImageSize,
                ImageImpression, // image impression type (live-scan, roll, etc, see definitions)
                finger_position, // pass an int[6]
                ImageResolution, // the scan resolution of the fingerprint image. See definitions
                w,
                h, // image dimensions
                ImageCompression // image compression: see definitions: pass a char[10]
                );
        if (PrintErrorMessage(RetVal, "Get_EFTStype4_Info") != true) {
            System.out.println("FAILURE, exit");
            return;
        }

        // get the image
        ImgPixels = ImagePtr.getPointer(0).getByteArray(0, ImageSize.getValue());
        for (int i = 0; i < ImageSize.getValue(); i++) {
            System.out.println("\tbyte " + (i + 1) + " of image is " + ImgPixels[i]);
        }
        for (int i = 0; i < 6; i++) {
            System.out.println("\tfinger_position at position " + (i + 1) + " is " + finger_position[i]);
        }
        System.out.println("w, h: " + w.getValue() + ", " + h.getValue());
        System.out.println("ImageImpression: " + ImageImpression.getValue());
        System.out.println("ImageResolution: " + ImageResolution.getValue());
        System.out.println("ImageCompression: "
                + new String(ImageCompression));
        System.out.println();

        /////////////////////////////////////////
        // CREATE TYPE-2 Record
        /////////////////////////////////////////
        System.out.println("//////////////////////////////////////////");
        System.out.println("**** CREATE TYPE-2 Record ****************");
        System.out.println("//////////////////////////////////////////");
        System.out.println();

        Pointer pRec2 = new Memory(Pointer.SIZE);

        RetVal = GBAN2K_DllWrapper.GBAN2K_Library.INSTANCE.CreateETFStype_2(
                pRec2, // RECORD**
                "GreenBit S.p.A.",
                "DactyScan84C",
                "SN 12345678",
                AmputationList);
        if (PrintErrorMessage(RetVal, "CreateETFStype_2") != true) {
            System.out.println("FAILURE, exit");
            return;
        }


        System.out.println("//////////////////////////////////////////");
        System.out.println("**** READ TYPE-2 RECORD ******************");
        System.out.println("//////////////////////////////////////////");
        System.out.println();

        Pointer rec2 = pRec2.getPointer(0);
        byte[] Mak = new byte[GBAN2K_EFTSType2Defines.MAX_MAK_LEN];
        byte[] Modl = new byte[GBAN2K_EFTSType2Defines.MAX_MODL_LEN];
        byte[] SerNo = new byte[GBAN2K_EFTSType2Defines.MAX_SERNO_LEN];
        RetVal = GBAN2K_DllWrapper.GBAN2K_Library.INSTANCE.Get_EFTStype2_Info(
                rec2,// RECORD*
                Mak,
                Modl,
                SerNo, // image impression type (live-scan, roll, etc, see definitions)
                pamp_list);
        if (PrintErrorMessage(RetVal, "Get_EFTStype2_Info") != true) {
            System.out.println("FAILURE, exit");
            return;
        }

        System.out.println("Maker: " + new String(Mak));
        System.out.println("Model: " + new String(Modl));
        System.out.println("Serial Number: " + new String(SerNo));
        // amputation list
        if (pamp_list.getPointer(0) != Pointer.NULL) {
            GBAN2K_FingerAmputionsList amp_list = new GBAN2K_FingerAmputionsList(pamp_list.getPointer(0));
            System.out.println("Num of fingers in amputation list: " + amp_list.num_fingers);
            for (int i = 0, offset = 0; i < amp_list.num_fingers; i++, offset += Pointer.SIZE) {
                GBAN2K_FingerAmputationStructure ampfinger = new GBAN2K_FingerAmputationStructure(amp_list.fingers.getPointer(offset));
                System.out.println("\tFingID: " + new String(ampfinger.fing_id) + ", Amp code: " + new String(ampfinger.amp_code));
            }
        }
        System.out.println();

        /////////////////////////////////////////
        // UPDATE TYPE-2 Record
        /////////////////////////////////////////
        System.out.println("//////////////////////////////////////////");
        System.out.println("**** UPDATE TYPE-2 Record ****************");
        System.out.println("//////////////////////////////////////////");
        System.out.println();

        RetVal = GBAN2K_DllWrapper.GBAN2K_Library.INSTANCE.UpdateETFStype_2(
                rec2, // RECORD**
                "GREENBIT S.p.A.",
                "MultiScan500",
                "SN 87654321",
                AmputationList);
        if (PrintErrorMessage(RetVal, "UpdateETFStype_2") != true) {
            System.out.println("FAILURE, exit");
            return;
        }
        RetVal = GBAN2K_DllWrapper.GBAN2K_Library.INSTANCE.Get_EFTStype2_Info(
                rec2,// RECORD*
                Mak,
                Modl,
                SerNo, // image impression type (live-scan, roll, etc, see definitions)
                pamp_list);
        if (PrintErrorMessage(RetVal, "Get_EFTStype2_Info") != true) {
            System.out.println("FAILURE, exit");
            return;
        }

        System.out.println("Maker: " + new String(Mak));
        System.out.println("Model: " + new String(Modl));
        System.out.println("Serial Number: " + new String(SerNo));
        // amputation list
        if (pamp_list.getPointer(0) != Pointer.NULL) {
            GBAN2K_FingerAmputionsList amp_list = new GBAN2K_FingerAmputionsList(pamp_list.getPointer(0));
            System.out.println("Num of fingers in amputation list: " + amp_list.num_fingers);
            for (int i = 0, offset = 0; i < amp_list.num_fingers; i++, offset += Pointer.SIZE) {
                GBAN2K_FingerAmputationStructure ampfinger = new GBAN2K_FingerAmputationStructure(amp_list.fingers.getPointer(offset));
                System.out.println("\tFingID: " + new String(ampfinger.fing_id) + ", Amp code: " + new String(ampfinger.amp_code));
            }
        }
        System.out.println();

        /////////////////////////////////////////
        // CREATE TYPE-15 Record
        // with a very simple image (6 bytes,
        // 2x3)
        /////////////////////////////////////////
        System.out.println("//////////////////////////////////////////");
        System.out.println("**** CREATE TYPE-15 Record ****************");
        System.out.println("//////////////////////////////////////////");
        System.out.println();

        Pointer pRec15 = new Memory(Pointer.SIZE);

        /***************************
         * create a fake 2x3 image
         */
        byte[] PalmprintImage = new byte[6];
        for (int i = 0; i < 6; i++) {
            PalmprintImage[i] = (byte) (i + 18);
        }
        int PPImageSize = 6;
        int PPImageWidth = 2,
                PPImageHeight = 3,
                BitsPerPixel = GBAN2K_PixelDepthDefines.PIXEL_DEPTH_8BPP;
        double PPImageResolutionPPMM = 19.26;
        CompressionType = GBAN2K_CompressionAlgorithmsDefines.COMP_JPEGL;
        ImpressionType = GBAN2K_ImpressionCodesDefines.ETFS_14_LATENT_IMPRESSION;
        ImageSource = "Fake police station";
        Comment = "Palm Comment";
        String PalmPosition = GBAN2K_PalmPositionsDefines.ETFS_15_PLP_LEFT_LOWER_PALM;

        AmputationList.fingers.setPointer(0, AmpStruct.getPointer());

        RetVal = GBAN2K_DllWrapper.GBAN2K_Library.INSTANCE.image2ETFStype_15(
                pRec15, // RECORD**
                PalmprintImage,
                PPImageSize,
                PPImageWidth,
                PPImageHeight,
                BitsPerPixel,
                PPImageResolutionPPMM,
                CompressionType,
                ImpressionType,
                ImageSource,
                Comment,
                PalmPosition,
                null);
        if (PrintErrorMessage(RetVal, "image2ETFStype_15") != true) {
            System.out.println("FAILURE, exit");
            return;
        }


        System.out.println("//////////////////////////////////////////");
        System.out.println("**** READ TYPE-15 RECORD *****************");
        System.out.println("//////////////////////////////////////////");
        System.out.println();

        Pointer rec15 = pRec15.getPointer(0);
        ImageCompression = new byte[10];
        source_str = new byte[44];
        comment = new byte[136];
        Pointer pPalmQuality = new Memory(Pointer.SIZE);
        IntByReference PalmBpp = new IntByReference();
        byte[] PalmPosBuffer = new byte[10];
        RetVal = GBAN2K_DllWrapper.GBAN2K_Library.INSTANCE.Get_EFTStype15_Info(
                rec15,// RECORD*				// input record
                ImagePtr, // unsigned char**
                ImageSize, // allocated memory for image frame (can be different from w x h)
                w,
                h, // image dimensions
                PalmBpp, // bits per pixel
                Resolution_ppmm, // resolution in pixel per mm
                ImageCompression, // image compression: see definitions: pass a char[10]
                ImageImpression, // image impression type (live-scan, roll, etc, see definitions)
                source_str, // string identifying the originating source of the image, pass a char[44]
                comment, // comment, pass a char[136]
                PalmPosBuffer, // string indicating the palm position. See definitions
                pPalmQuality // PALM_QUAL_LIST**
                );
        if (PrintErrorMessage(RetVal, "Get_EFTStype15_Info") != true) {
            System.out.println("FAILURE, exit");
            return;
        }

        // get the image
        ImgPixels = ImagePtr.getPointer(0).getByteArray(0, ImageSize.getValue());
        for (int i = 0; i < ImageSize.getValue(); i++) {
            System.out.println("\tbyte " + (i + 1) + " of image is " + ImgPixels[i]);
        }
        System.out.println("w, h: " + w.getValue() + ", " + h.getValue());
        System.out.println("ImageImpression: " + ImageImpression.getValue());
        System.out.println("Bits per pixel: " + PalmBpp.getValue());
        System.out.println("Resolution_ppmm: " + Resolution_ppmm.getValue());
        System.out.println("ImageCompression: "
                + new String(ImageCompression));
        System.out.println("Source: "
                + new String(source_str));
        System.out.println("Comment: "
                + new String(comment));
        System.out.println("Palm position: "
                + new String(PalmPosBuffer));
        System.out.println();


        System.out.println("//////////////////////////////////////////");
        System.out.println("**** UPDATE TYPE-15 RECORD ***************");
        System.out.println("//////////////////////////////////////////");
        System.out.println();

        for (int i = 0; i < 6; i++) {
            PalmprintImage[i] = (byte) (i + 24);
        }

        RetVal = GBAN2K_DllWrapper.GBAN2K_Library.INSTANCE.UpdateETFStype_15(
                rec15,// RECORD*
                PalmprintImage,
                PPImageSize,
                1,
                6,
                7.15,
                null);
        if (PrintErrorMessage(RetVal, "UpdateETFStype_15") != true) {
            System.out.println("FAILURE, exit");
            return;
        }
        RetVal = GBAN2K_DllWrapper.GBAN2K_Library.INSTANCE.Get_EFTStype15_Info(
                rec15,// RECORD*				// input record
                ImagePtr, // unsigned char**
                ImageSize, // allocated memory for image frame (can be different from w x h)
                w,
                h, // image dimensions
                PalmBpp, // bits per pixel
                Resolution_ppmm, // resolution in pixel per mm
                ImageCompression, // image compression: see definitions: pass a char[10]
                ImageImpression, // image impression type (live-scan, roll, etc, see definitions)
                source_str, // string identifying the originating source of the image, pass a char[44]
                comment, // comment, pass a char[136]
                PalmPosBuffer, // string indicating the palm position. See definitions
                pPalmQuality // PALM_QUAL_LIST**
                );
        if (PrintErrorMessage(RetVal, "Get_EFTStype15_Info") != true) {
            System.out.println("FAILURE, exit");
            return;
        }

        // get the image
        ImgPixels = ImagePtr.getPointer(0).getByteArray(0, ImageSize.getValue());
        for (int i = 0; i < ImageSize.getValue(); i++) {
            System.out.println("\tbyte " + (i + 1) + " of image is " + ImgPixels[i]);
        }
        System.out.println("w, h: " + w.getValue() + ", " + h.getValue());
        System.out.println("ImageImpression: " + ImageImpression.getValue());
        System.out.println("Bits per pixel: " + PalmBpp.getValue());
        System.out.println("Resolution_ppmm: " + Resolution_ppmm.getValue());
        System.out.println("ImageCompression: "
                + new String(ImageCompression));
        System.out.println("Source: "
                + new String(source_str));
        System.out.println("Comment: "
                + new String(comment));
        System.out.println("Palm position: "
                + new String(PalmPosBuffer));
        System.out.println();

        //////////////////////////////////
        // INSERT ALL RECORDS IN AN STRUCT
        //////////////////////////////////
        System.out.println("//////////////////////////////////////////");
        System.out.println("**** INSERT ALL RECORDS IN AN STRUCT *****");
        System.out.println("//////////////////////////////////////////");
        System.out.println();
        RetVal = GBAN2K_DllWrapper.GBAN2K_Library.INSTANCE.insert_ANSI_NIST_record_ETFS(
                MyAnsiNist.num_records,
                rec2, // RECORD*
                MyAnsiNist.getPointer() // GBAN2K_AnsiNistStructure *
                );
        if (PrintErrorMessage(RetVal, "insert_ANSI_NIST_record_ETFS") != true) {
            System.out.println("FAILURE, exit");
            return;
        }
        MyAnsiNist.read();
        RetVal = GBAN2K_DllWrapper.GBAN2K_Library.INSTANCE.insert_ANSI_NIST_record_ETFS(
                MyAnsiNist.num_records,
                rec4, // RECORD*
                MyAnsiNist.getPointer() // GBAN2K_AnsiNistStructure *
                );
        if (PrintErrorMessage(RetVal, "insert_ANSI_NIST_record_ETFS") != true) {
            System.out.println("FAILURE, exit");
            return;
        }
        MyAnsiNist.read();
        RetVal = GBAN2K_DllWrapper.GBAN2K_Library.INSTANCE.insert_ANSI_NIST_record_ETFS(
                MyAnsiNist.num_records,
                rec14, // RECORD*
                MyAnsiNist.getPointer() // GBAN2K_AnsiNistStructure *
                );
        if (PrintErrorMessage(RetVal, "insert_ANSI_NIST_record_ETFS") != true) {
            System.out.println("FAILURE, exit");
            return;
        }
        MyAnsiNist.read();
        RetVal = GBAN2K_DllWrapper.GBAN2K_Library.INSTANCE.insert_ANSI_NIST_record_ETFS(
                MyAnsiNist.num_records,
                rec15, // RECORD*
                MyAnsiNist.getPointer() // GBAN2K_AnsiNistStructure *
                );
        if (PrintErrorMessage(RetVal, "insert_ANSI_NIST_record_ETFS") != true) {
            System.out.println("FAILURE, exit");
            return;
        }

        MyAnsiNist.read();
        System.out.println("num records after insertion: " + MyAnsiNist.num_records);

        /////////////////////////////////
        // SEARCH RECORD IN AN STRUCT
        /////////////////////////////////
        System.out.println("//////////////////////////////////////////");
        System.out.println("**** SEARCH RECORD IN AN STRUCT **********");
        System.out.println("//////////////////////////////////////////");
        System.out.println();

        Pointer pRecList = new Memory(Pointer.SIZE);
        RetVal = GBAN2K_DllWrapper.GBAN2K_Library.INSTANCE.search_ANSI_NIST_record(
                pRecList,
                GBAN2K_AnsiNistRecordsDefines.TYPE_15_ID,
                MyAnsiNist);
        if (PrintErrorMessage(RetVal, "search_ANSI_NIST_record") != true) {
            System.out.println("FAILURE, exit");
            return;
        }

        GBAN2K_RecordListStructure MyRecList = new GBAN2K_RecordListStructure(pRecList.getPointer(0));
        System.out.println("MyRecList.num_records: " + MyRecList.num_records);

        /////////////////////////////////
        // WRITE AN STRUCT TO BUFFER
        /////////////////////////////////
        System.out.println("//////////////////////////////////////////");
        System.out.println("**** WRITE AN STRUCT TO BUFFER **********");
        System.out.println("//////////////////////////////////////////");
        System.out.println();

        Pointer pOutBuffer = new Memory(Pointer.SIZE);
        IntByReference BufLen = new IntByReference();
        RetVal = GBAN2K_DllWrapper.GBAN2K_Library.INSTANCE.write_ANSI_NIST_2_buffer(
                pOutBuffer,
                BufLen,
                MyAnsiNist);
        if (PrintErrorMessage(RetVal, "write_ANSI_NIST_2_buffer") != true) {
            System.out.println("FAILURE, exit");
            return;
        }
        
        WriteAllBytes("./Example.ansi", pOutBuffer.getPointer(0).getByteArray(0, BufLen.getValue()));

        ////////////////////////////////////
        // DELETE ALL RECORDS FROM AN STRUCT
        ////////////////////////////////////
        System.out.println("//////////////////////////////////////////");
        System.out.println("**** DELETE ALL RECORDS FROM AN STRUCT ***");
        System.out.println("//////////////////////////////////////////");
        System.out.println();
        while (MyAnsiNist.num_records > 1) {
            RetVal = GBAN2K_DllWrapper.GBAN2K_Library.INSTANCE.delete_ANSI_NIST_record(
                    1,
                    MyAnsiNist.getPointer() // GBAN2K_AnsiNistStructure *
                    );
            if (PrintErrorMessage(RetVal, "delete_ANSI_NIST_record") != true) {
                System.out.println("FAILURE, exit");
                return;
            }

            MyAnsiNist.read();
            System.out.println("num records after delete: " + MyAnsiNist.num_records);
        }

        ////////////////////////////////////
        // DELETE AN STRUCT
        ////////////////////////////////////
        System.out.println("//////////////////////////////////////////");
        System.out.println("**** DELETE AN STRUCT ********************");
        System.out.println("//////////////////////////////////////////");
        System.out.println();

        GBAN2K_DllWrapper.GBAN2K_Library.INSTANCE.free_ANSI_NIST(pAnsiNist.getPointer(0));

        ////////////////////////////////////
        // RELOAD AN STRUCT
        ////////////////////////////////////
        System.out.println("//////////////////////////////////////////");
        System.out.println("**** RELOAD AN STRUCT ********************");
        System.out.println("//////////////////////////////////////////");
        System.out.println();

        RetVal = GBAN2K_DllWrapper.GBAN2K_Library.INSTANCE.read_ANSI_NIST_buffer(
                pOutBuffer.getPointer(0).getByteArray(0, BufLen.getValue()),
                BufLen.getValue(),
                pAnsiNist);
        if (PrintErrorMessage(RetVal, "read_ANSI_NIST_buffer") != true) {
            System.out.println("FAILURE, exit");
            return;
        }
        
        MyAnsiNist = new GBAN2K_AnsiNistStructure(pAnsiNist.getPointer(0));
        System.out.println("num records: " + MyAnsiNist.num_records);
        System.out.println("version  : " + MyAnsiNist.version);
        System.out.println("num   bytes: " + MyAnsiNist.num_bytes);
    }
}
