/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package test_gbmsgui_qt_java;

import GBMSGUI_QT_Defines.GBMSGUI_AcquisitionModes;
import GBMSGUI_QT_Defines.GBMSGUI_AcquisitionOptions;
import GBMSGUI_QT_Defines.GBMSGUI_ErrorCodes;
import GBMSGUI_QT_Defines.GBMSGUI_QualityAlgorithms;
import GBMSGUI_QT_Defines.GBMSGUI_ReturnCodes;
import GBMSGUI_QT_Defines.GBMSGUI_SessionOptions;
import GBMSGUI_QT_Defines.GBMSGUI_UnavailabilityReason;
import GBMSGUI_QT_LibraryFunctions.GBMSGUI_QT_DLL_Wrapper;
import com.sun.jna.Library;
import com.sun.jna.Native;
import com.sun.jna.Platform;
import com.sun.jna.Pointer;
import com.sun.jna.Callback;
import com.sun.jna.ptr.IntByReference;
import com.sun.jna.ptr.LongByReference;
import com.sun.jna.ptr.ByteByReference;
import com.sun.jna.ptr.DoubleByReference;
import GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_DeviceCharacteristicsDefines.*;
import com.sun.jna.WString;

import java.io.*;
import java.util.Date;

import GBMSGUI_QT_LibraryFunctions.GBMSGUI_QT_DLL_Wrapper.GBMSGUI_QT_Library;
import com.sun.jna.NativeLong;

/**
 *
 * @author andrea
 */
public class Test_GBMSGUI_QT_Java {

	/**
	 * @param args the command line arguments
	 */
	public static void main(String[] args) {
		int RetVal;
		/////////////////////////////
		// Loading library
		///////////////////////////////
		System.out.println("//////////////////////////////////////////");
		System.out.println("**** LOADING LIBRARY *********************");
		System.out.println("//////////////////////////////////////////");
		System.out.println();
		
		GBMSGUI_QT_Library.INSTANCE.GBMSGUI_Load();
		
		// Get Version
		IntByReference maj = new IntByReference(2),
				min = new IntByReference(2),
				bui = new IntByReference(2),
				Rev = new IntByReference(2);
		GBMSGUI_QT_Library.INSTANCE.GBMSGUI_GetVersion(maj, min, bui, Rev);
		System.out.println("GBMSGUI Version: " +
				maj.getValue() + "." +
				min.getValue() + "." +
				bui.getValue() + "." +
				Rev.getValue());
		System.out.println();
		
		/////////////////////////////////////
		// Starting Session
		/////////////////////////////////////
		System.out.println("//////////////////////////////////////////");
		System.out.println("**** STARTING ACQUISITION SESSION ********");
		System.out.println("//////////////////////////////////////////");
		System.out.println();
		WString PersonID = new WString("John Doe");
		RetVal = GBMSGUI_QT_Library.INSTANCE.GBMSGUI_StartSession(
				GBMSGUI_AcquisitionModes.GBMSGUI_AM_SINGLE_ACQUISITION,
				PersonID,
				0);
		System.out.println("GBMSGUI_StartSession returned: " + RetVal);
		if (RetVal != GBMSGUI_ReturnCodes.GBMSGUI_JAVA_RET_SUCCESS)
		{
			System.out.println("FAILURE, exit");
			return;
		}
		
		/////////////////////////////////////
		// Acquiring object
		/////////////////////////////////////
		System.out.println("//////////////////////////////////////////");
		System.out.println("**** ACQUIRING OBJECT ********************");
		System.out.println("//////////////////////////////////////////");
		System.out.println();
		byte [] ImgBuffer = new byte[4000000];
		NativeLong ImgBuffSize = new NativeLong(4000000);
		IntByReference pImageSizeX = new IntByReference(0),
				pImageSizeY = new IntByReference(0),
				pDpi = new IntByReference(0);
		System.out.println("pImageSizeX: " + pImageSizeX);
		System.out.println("pImageSizeY: " + pImageSizeY);
		System.out.println("pDpi: " + pDpi);
				
		RetVal = GBMSGUI_QT_Library.INSTANCE.GBMSGUI_Acquire(
				GBMSAPI_JAVA_ScannableObjects.GBMSAPI_JAVA_SO_FLAT_LEFT_INDEX,
				GBMSGUI_AcquisitionOptions.GBMSGUI_ACQUISITION_OPTION_AUTOCAPTURE,
				ImgBuffer, 
				ImgBuffSize,
				pImageSizeX, pImageSizeY,
				pDpi);
		System.out.println("GBMSGUI_Acquire returned: " + RetVal);
		if (RetVal != GBMSGUI_ReturnCodes.GBMSGUI_JAVA_RET_SUCCESS)
		{
			System.out.println("FAILURE, exit");
			return;
		}
		System.out.println("Returned Image Size: " +
				pImageSizeX.getValue() + ", " + pImageSizeY.getValue());
		System.out.println("Image DPI: " + pDpi.getValue());
		System.out.println();
		
		//////////////////////////////////////
		// Stopping session
		//////////////////////////////////////
		System.out.println("//////////////////////////////////////////");
		System.out.println("**** STOPPING ACQUISITION SESSION ********");
		System.out.println("//////////////////////////////////////////");
		System.out.println();
		RetVal = GBMSGUI_QT_Library.INSTANCE.GBMSGUI_StopSession();
		System.out.println("GBMSGUI_StopSession returned: " + RetVal);
		if (RetVal != GBMSGUI_ReturnCodes.GBMSGUI_JAVA_RET_SUCCESS)
		{
			System.out.println("FAILURE, exit");
			return;
		}
		
		///////////////////////////////////////
		// Getting size of window
		///////////////////////////////////////
		IntByReference Left = new IntByReference(0),
				Top = new IntByReference(0),
				Width = new IntByReference(0),
				Height = new IntByReference(0),
				Maximized = new IntByReference(0);
		RetVal = GBMSGUI_QT_Library.INSTANCE.GBMSGUI_GetWindowSizeAndPosition(
				Left, Top, Width, Height, Maximized);
		System.out.println("GBMSGUI_GetWindowSizeAndPosition returned: " + RetVal);
		if (RetVal != GBMSGUI_ReturnCodes.GBMSGUI_JAVA_RET_SUCCESS)
		{
			System.out.println("FAILURE, exit");
			return;
		}
		System.out.println("Window Size: " +
				Width.getValue() + ", " + Height.getValue());
		System.out.println("Window Position: " +
				Left.getValue() + ", " + Top.getValue());
		System.out.println();
		/////////////////////////////
		// Unloading library
		///////////////////////////////
		System.out.println("//////////////////////////////////////////");
		System.out.println("**** UNLOADING LIBRARY *******************");
		System.out.println("//////////////////////////////////////////");
		System.out.println();
		
		GBMSGUI_QT_Library.INSTANCE.GBMSGUI_Unload();

		try
		{
			System.in.read();
		}
		catch(Exception ex)
		{
		}
	}
}
