﻿using System;
using System.Collections.Generic;
using System.Text;
using WSQPACK_NET_WRAPPER;
using System.IO;

namespace TestWSQ_Console_CS
{
    class Program
    {
        public class WsqGlobals
        {
            public const int ImgSX = 500;
            public const int ImgSY = 500;
            public const int BitPerPixel = 8;
            public const int ImageResolution = 500;
            public const float CompressionRate = (float)0.75;
        }
        static void Main(string[] args)
        {
            byte[] ImgBuffer = File.ReadAllBytes("sample.raw");
            WSQPACK_NET_WRAPPER.NW_WSQPACK_Compress x = new NW_WSQPACK_Compress(
                ImgBuffer, WsqGlobals.ImgSX, WsqGlobals.ImgSY);
            x.BitPerPixel = WsqGlobals.BitPerPixel;
            x.CompressionRate = WsqGlobals.CompressionRate;
            x.ImageResolution = WsqGlobals.ImageResolution;
            x.WSQComment = null;

            byte []CompressedBuffer = x.Encoded;
            File.WriteAllBytes("sample.wsq", CompressedBuffer);

            WSQPACK_NET_WRAPPER.NW_WSQPACK_Uncompress y = new NW_WSQPACK_Uncompress(CompressedBuffer);
            WSQPACK_NET_WRAPPER.NW_WSQPACK_DecoderInfo j = y.ImageDecoded;
            Console.WriteLine("j.BitsPerPixel: " + j.BitsPerPixel);
            Console.WriteLine("j.ImageHeight: " + j.ImageHeight);
            Console.WriteLine("j.ImageResolution: " + j.ImageResolution);
            Console.WriteLine("j.ImageWidth: " + j.ImageWidth);
            File.WriteAllBytes("Sample1.raw", j.RawImage);
            Console.WriteLine("j.RawImage: " + j.RawImage);

            Console.Read();
            Console.Read();
        }
    }
}
