/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package GBMSGUI_QT_LibraryFunctions;

import com.sun.jna.Library;
import com.sun.jna.Native;
import com.sun.jna.Pointer;
import com.sun.jna.NativeLong;
import com.sun.jna.ptr.IntByReference;
import com.sun.jna.ptr.ByteByReference;
import com.sun.jna.ptr.PointerByReference;
import com.sun.jna.ptr.DoubleByReference;
import com.sun.jna.WString;
import GBMSGUI_QT_LibraryFunctions.GBMSGUI_AfterStartCallbackInterface;

/**
 *
 * @author andrea
 */
public class GBMSGUI_QT_DLL_Wrapper {

	public interface GBMSGUI_QT_Library extends Library {

		GBMSGUI_QT_Library INSTANCE =
				(GBMSGUI_QT_Library) Native.loadLibrary("GBMSGUI_Qt", GBMSGUI_QT_Library.class);

		/**
		 * 
		 */
		void GBMSGUI_Load();

		/**
		 * 
		 * @param LangName
		 *	two-letter Language ID, must match the <langID> part in the language file name
		 * @return 
		 * @see GBMSGUI_QT_Defines.GBMSGUI_ReturnCodes
		 */
		int GBMSGUI_SetLanguage(String LangName);

		/**
		 * 
		 * @param Major (output) Major version number
		 * @param Minor (output) Minor version number
		 * @param Build (output) Build number
		 * @param Revision (output) Revision number
		 */
		void GBMSGUI_GetVersion(
				IntByReference Major,
				IntByReference Minor,
				IntByReference Build,
				IntByReference Revision);

		/**
		 * 
		 * @param Left coordinates of the top left corner of the window
		 * @param Top coordinates of the top left corner of the window
		 * @param Width size of the window
		 * @param Height size of the window
		 * @param Maximized true if the window is wanted in maximized state
		 * @return  
		 * @see GBMSGUI_QT_Defines.GBMSGUI_ReturnCodes
		 */
		int GBMSGUI_SetWindowSizeAndPosition(
				int Left, int Top,
				int Width, int Height,
				boolean Maximized);

		/**
		 * 
		 * @param Threshold1 values of the thresholds, in mm2
		 * @param Threshold2 values of the thresholds, in mm2
		 * @return  
		 * @see GBMSGUI_QT_Defines.GBMSGUI_ReturnCodes
		 */
		int GBMSGUI_SetArtefactsThresholds(int Threshold1, int Threshold2);

		/**
		 * 
		 * @param AlgorithmID
		 * @see GBMSGUI_QT_Defines.GBMSGUI_QualityAlgorithms
		 * @return  
		 * @see GBMSGUI_QT_Defines.GBMSGUI_ReturnCodes
		 */
		int GBMSGUI_SetQualityAlgorithm(int AlgorithmID);

		/**
		 * 
		 * @param Threshold value of the threshold (0-100)
		 * @return
		 * @see GBMSGUI_QT_Defines.GBMSGUI_ReturnCodes 
		 */
		int GBMSGUI_SetPatternValidityThreshold(int Threshold);

		/**
		 * 
		 * @param Threshold value of the threshold (0-100)
		 * @return 
		 * @see GBMSGUI_QT_Defines.GBMSGUI_ReturnCodes
		 */
		int GBMSGUI_SetPatternCompletenessThreshold(int Threshold);

		/**
		 * 
		 * @param Threshold1
		 * @param Threshold2
		 * @return
		 * @see GBMSGUI_QT_Defines.GBMSGUI_ReturnCodes 
		 */
		int GBMSGUI_SetLowerPalmCompletenessThresholds(int Threshold1, int Threshold2);

		/**
		 * 
		 * @param Threshold
		 * @return 
		 * @see GBMSGUI_QT_Defines.GBMSGUI_ReturnCodes
		 */
		int GBMSGUI_SetInclinationThreshold(int Threshold);

		/**
		 * 
		 * @param Mask
		 * Native is an int32
		 * see point (1) of ReadME.txt file 
		 * @return 
		 * @see GBMSGUI_QT_Defines.GBMSGUI_ReturnCodes
		 */
		int GBMSGUI_SetBlockAutoCaptureMask(int Mask);

		/**
		 * 
		 * @param Flag
		 * @return 
		 * @see GBMSGUI_QT_Defines.GBMSGUI_ReturnCodes 
		 */
		//int GBMSGUI_SetBlockAutoCaptureContrast(boolean Flag);

		/**
		 * 
		 * @param IgnoreDiagnosticMask
		 * Native is an int32
		 * see point (1) of ReadME.txt file
		 * @return  
		 * @see GBMSGUI_QT_Defines.GBMSGUI_ReturnCodes
		 */
		int GBMSGUI_SetIgnoreDiagnosticMask(int IgnoreDiagnosticMask);

		/**
		 * 
		 * @param FlatFingerOnRollArea
		 * @return  
		 * @see GBMSGUI_QT_Defines.GBMSGUI_ReturnCodes
		 */
		//int GBMSGUI_SetFlatFingerOnRollArea(boolean FlatFingerOnRollArea);

		/**
		 * 
		 * @param AcquisitionMode
		 * @param PersonID
		 * @param Options
		 * Native is an int32
		 * see point (1) of ReadME.txt file
		 * @return 
		 * @see GBMSGUI_QT_Defines.GBMSGUI_ReturnCodes
		 */
		int GBMSGUI_StartSession(int AcquisitionMode, WString PersonID, int Options);

		/**
		 * 
		 * @param ScannedObjectID
		 * Native is an int32
		 * see point (1) of ReadME.txt file
		 * @param Width
		 * Native is an int32
		 * see point (1) of ReadME.txt file
		 * @param Height
		 * Native is an int32
		 * see point (1) of ReadME.txt file
		 * @return 
		 * @see GBMSGUI_QT_Defines.GBMSGUI_ReturnCodes
		 */
		int GBMSGUI_SetImageSize(int ScannedObjectID, int Width, int Height);

		/**
		 * 
		 * @param ScannedObjectID
		 * Native is an int32
		 * see point (1) of ReadME.txt file
		 * @param Threshold1
		 * @param Threshold2
		 * @return 
		 * @see GBMSGUI_QT_Defines.GBMSGUI_ReturnCodes
		 */
		int GBMSGUI_SetContrastThresholds(int ScannedObjectID, int Threshold1, int Threshold2);

		/**
		 * 
		 * @param ScannedObjectID
		 * Native is an int32
		 * see point (1) of ReadME.txt file
		 * @param Threshold1
		 * @param Threshold2
		 * @return 
		 * @see GBMSGUI_QT_Defines.GBMSGUI_ReturnCodes
		 */
		int GBMSGUI_SetQualityThresholds(int ScannedObjectID, int Threshold1, int Threshold2);

		/**
		 * 
		 * @param ScannedObjectID
		 * Native is an int32
		 * see point (1) of ReadME.txt file
		 * @param Index
		 * @param Width
		 * Native is an int32
		 * see point (1) of ReadME.txt file
		 * @param Height
		 * Native is an int32
		 * see point (1) of ReadME.txt file
		 * @return
		 * @see GBMSGUI_QT_Defines.GBMSGUI_ReturnCodes 
		 */
		int GBMSGUI_SetSegmentImageSize(
				int ScannedObjectID,
				int Index,
				int Width,
				int Height);

		/**
		 * 
		 * @param ScannedObjectID
		 * Native is an int32
		 * see point (1) of ReadME.txt file
		 * @param Index
		 * @param Threshold1
		 * @param Threshold2
		 * @return 
		 * @see GBMSGUI_QT_Defines.GBMSGUI_ReturnCodes
		 */
		int GBMSGUI_SetSegmentQualityThresholds(
				int ScannedObjectID,
				int Index,
				int Threshold1,
				int Threshold2);

		/**
		 * 
		 * @param ScannedObjectID
		 * Native is an int32
		 * see point (1) of ReadME.txt file
		 * @param Index
		 * @param Reason
		 * @return 
		 * @see GBMSGUI_QT_Defines.GBMSGUI_ReturnCodes
		 */
		int GBMSGUI_SetSegmentUnavailabilityReason(
				int ScannedObjectID,
				int Index,
				int Reason);

		/**
		 * 
		 * @param AfterStartFunc
		 * @param AfterStartParam 
		 */
		void GBMSGUI_SetAfterStartCallback(
				GBMSGUI_AfterStartCallbackInterface AfterStartFunc,
				Pointer AfterStartParam);

		/**
		 * 
		 * @param ScannedObjectID
		 * Native is an int32
		 * see point (1) of ReadME.txt file
		 * @param Options
		 * Native is an int32
		 * see point (1) of ReadME.txt file
		 * @param Image
		 * @param ImageBufferSize
		 * @param ImageSizeX
		 * @param ImageSizeY
		 * @param Dpi
		 * @return  
		 * @see GBMSGUI_QT_Defines.GBMSGUI_ReturnCodes
		 */
		int GBMSGUI_Acquire(
				int ScannedObjectID,
				int Options,
				byte[] Image,
				NativeLong ImageBufferSize,
				IntByReference ImageSizeX,
				IntByReference ImageSizeY,
				IntByReference Dpi);

		/**
		 * 
		 * @param ScannedObjectID
		 * Native is an int32
		 * see point (1) of ReadME.txt file
		 * @param QualityAlgorithm
		 * @param Quality
		 * @return  
		 * @see GBMSGUI_QT_Defines.GBMSGUI_ReturnCodes
		 */
		int GBMSGUI_GetIAFISQuality(
				int ScannedObjectID,
				int QualityAlgorithm,
				IntByReference Quality);

		/**
		 * 
		 * @param ScannedObjectID
		 * Native is an int32
		 * see point (1) of ReadME.txt file
		 * @param Reason
		 * @return  
		 * @see GBMSGUI_QT_Defines.GBMSGUI_ReturnCodes
		 */
		int GBMSGUI_GetUnavailabilityReason(
				int ScannedObjectID,
				IntByReference Reason);

		/**
		 * 
		 * @param Index
		 * @param QualityAlgorithmID
		 * @param SegmentAvailable
		 * Native is a bool *
		 * @param Left
		 * @param Top
		 * @param Right
		 * @param Bottom
		 * @param UnavailabilityReason
		 * @param FingerprintQuality
		 * @param ImageBuffer
		 * @param ImageBufferSize
		 * @param ImageSizeX
		 * @param ImageSizeY
		 * @param Dpi
		 * @return 
		 * @see GBMSGUI_QT_Defines.GBMSGUI_ReturnCodes 
		 */
		int GBMSGUI_GetSegmentationResult(
				int Index,
				int QualityAlgorithmID,
				IntByReference SegmentAvailable,
				IntByReference Left,
				IntByReference Top,
				IntByReference Right,
				IntByReference Bottom,
				IntByReference UnavailabilityReason,
				IntByReference FingerprintQuality,
				byte[] ImageBuffer,
				int ImageBufferSize,
				IntByReference ImageSizeX,
				IntByReference ImageSizeY,
				IntByReference Dpi);

		/**
		 * 
		 * @return  
		 * @see GBMSGUI_QT_Defines.GBMSGUI_ReturnCodes
		 */
		int GBMSGUI_StopSession();

		/**
		 * 
		 * @param Left
		 * @param Top
		 * @param Width
		 * @param Height
		 * @param Maximized
		 * Native is a bool *
		 * @return  
		 * @see GBMSGUI_QT_Defines.GBMSGUI_ReturnCodes
		 */
		int GBMSGUI_GetWindowSizeAndPosition(
				IntByReference Left, IntByReference Top,
				IntByReference Width,
				IntByReference Height,
				IntByReference Maximized // DA PROVARE era Boolean*
				);

		/**
		 * 
		 * @return wide char string containing error message
		 */
		WString GBMSGUI_GetErrorMessage();

		/**
		 * 
		 * @return
		 * @see GBMSGUI_QT_Defines.GBMSGUI_ErrorCodes
		 */
		int GBMSGUI_GetErrorCode();

		/**
		 * 
		 */
		void GBMSGUI_Unload();

		/**
		 * 
		 * @param FuncName
		 * @param ErrCode
		 * @return  wide char string containing error message
		 */
		WString GBMSGUI_GetMSAPIErrorMessage(WString FuncName, int ErrCode);

		/**
		 * 
		 * @param ScanObjID
		 * Native is an int32
		 * see point (1) of ReadME.txt file
		 * @return 
		 */
//		boolean GBMSGUI_IsSlap(int ScanObjID);

		/**
		 * 
		 * @param ScanObjID
		 * Native is an int32
		 * see point (1) of ReadME.txt file
		 * @return 
		 */
//		Boolean GBMSGUI_IsRolled(int ScanObjID);

		/**
		 * 
		 * @param ScanObjID
		 * Native is an int32
		 * see point (1) of ReadME.txt file
		 * @return 
		 */
//		Boolean GBMSGUI_IsSingleFinger(int ScanObjID);

		/**
		 * 
		 * @param ScanObjID
		 * Native is an int32
		 * see point (1) of ReadME.txt file
		 * @return 
		 */
//		Boolean GBMSGUI_IsFlatSingleFinger(int ScanObjID);

		/**
		 * 
		 * @param ScanObjID
		 * Native is an int32
		 * see point (1) of ReadME.txt file
		 * @return 
		 */
//		Boolean GBMSGUI_IsPalm(int ScanObjID);

		/**
		 * 
		 * @param ScanObjID
		 * Native is an int32
		 * see point (1) of ReadME.txt file
		 * @return 
		 */
//		Boolean GBMSGUI_IsLowerPalm(int ScanObjID);

		/**
		 * 
		 * @param ScanObjID
		 * Native is an int32
		 * see point (1) of ReadME.txt file
		 * @return 
		 */
//		Boolean GBMSGUI_IsUpperPalm(int ScanObjID);

		/**
		 * 
		 * @param ScanObjID
		 * Native is an int32
		 * see point (1) of ReadME.txt file
		 * @return 
		 */
//		Boolean GBMSGUI_IsWritersPalm(int ScanObjID);
	}
}
