/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package GBAN2K_JAVA_LibraryFunctions;

import GBAN2K_JAVA_Structures.GBAN2K_AlternateQualityList;
import GBAN2K_JAVA_Structures.GBAN2K_FingerAmputionsList;
import GBAN2K_JAVA_Structures.GBAN2K_FourFingersBoundsStructure;
import GBAN2K_JAVA_Structures.GBAN2K_FourFingersQualitiesStructure;
import GBAN2K_JAVA_Structures.GBAN2K_PalmQualityList;
import GBAN2K_JAVA_Structures.GBAN2K_AnsiNistStructure;
import GBAN2K_JAVA_Structures.GBAN2K_RecordStructure;
import GBAN2K_JAVA_Structures.GBAN2K_FieldStructure;
import GBAN2K_JAVA_Structures.GBAN2K_ItemStructure;
import GBAN2K_JAVA_Structures.GBAN2K_RecordListStructure;
import GBAN2K_JAVA_Structures.GBAN2K_SubfieldStructure;
import com.sun.jna.Library;
import com.sun.jna.Native;
import com.sun.jna.Pointer;
import com.sun.jna.ptr.IntByReference;
import com.sun.jna.ptr.ByteByReference;
import com.sun.jna.ptr.PointerByReference;
import com.sun.jna.ptr.DoubleByReference;
import com.sun.jna.ptr.FloatByReference;

/**
 *
 * @author andrea
 */
public class GBAN2K_DllWrapper {

    /**
     *
     */
    public interface GBAN2K_Library extends Library {

        /**
         * Inherited for loading native dll
         */
        GBAN2K_Library INSTANCE = (GBAN2K_Library) Native.loadLibrary("AN2K_LIB", GBAN2K_Library.class);

        /**
         * 
         * @param oansi_nist
         * @param Version
         * @param TypeOfTransaction
         * @param Priority
         * @param DestinationAgency
         * @param OriginatingAgency
         * @param TransactionControlID
         * @param TransactionControlReference
         * @param NominalScanningResolution
         * @param NominalTransmitResolution
         * @param DomainNameID
         * @return @see GBAN2K_JAVA_Defines
         */
        int Create_ANSI_NIST(
                Pointer oansi_nist, // ANSI_NIST**
                int Version,
                String TypeOfTransaction,
                int Priority,
                String DestinationAgency,
                String OriginatingAgency,
                String TransactionControlID,
                String TransactionControlReference,
                float NominalScanningResolution,
                float NominalTransmitResolution,
                String DomainNameID);

        /**
         * 
         * @param record
         * @param Version
         * @param TransactionType
         * @param Priority
         * @param pDestinationAgency
         * @param DestAgencyLen
         * @param pOriginatingAgency
         * @param OriginatingAgencyLen
         * @param pTransContrNum
         * @param TransContrNumLen
         * @param pTransContrRef
         * @param TransContrRefLen
         * @param NominalScanRes
         * @param NominalTXRes
         * @param pDomain
         * @param DomainLen
         * @return @see GBAN2K_JAVA_Defines
         */
        int GetEFTSType1_Info(
                Pointer record, // RECORD *
                IntByReference Version, // version
                byte[] TransactionType, // pass a char[12]
                IntByReference Priority, // priority
                Pointer pDestinationAgency, //char**: no limits on length of this field, so
                // a developer needs next field:
                IntByReference DestAgencyLen, // DestinationAgency string length
                Pointer pOriginatingAgency, // //char**: no limits on length of this field, so
                // a developer needs next field:
                IntByReference OriginatingAgencyLen, // OriginatingAgency string length
                Pointer pTransContrNum, // //char**: no limits on length of this field, so
                // a developer needs next field:
                IntByReference TransContrNumLen, // TransContrNum string length 
                Pointer pTransContrRef, // //char**: no limits on length of this field, so
                // a developer needs next field:
                IntByReference TransContrRefLen, // TransContrRef string length
                FloatByReference NominalScanRes, // Nominal Scanning Resolution
                FloatByReference NominalTXRes, // Nominal Transmitting Resolution
                Pointer pDomain, // //char**: no limits on length of this field, so
                // a developer needs next field:
                IntByReference DomainLen // Domain string length
                );

        /**
         * 
         * @param record
         * @param NominalScanningResolution
         * @param NominalTransmitResolution
         * @return @see GBAN2K_JAVA_Defines
         */
        int UpdateETFStype_1(
                Pointer record, // RECORD *
                float NominalScanningResolution,
                float NominalTransmitResolution);

        int image2ETFStype_14(
                Pointer orecord, // RECORD**
                byte[] FingerprintImage,
                int FPImageSize,
                int FPImageWidth,
                int FPImageHeight,
                int FPImagePixelDepth,
                double ScanResolutionPPMM,
                String CompressionType,
                int ImpressionType,
                String ImageSource,
                String Comment,
                String FingerPosition,
                GBAN2K_FingerAmputionsList AmputationList,
                GBAN2K_FourFingersBoundsStructure boundaries,
                GBAN2K_FourFingersQualitiesStructure qualities,
                GBAN2K_AlternateQualityList segqual,
                GBAN2K_AlternateQualityList altqual);

        int UpdateETFStype_14(
                Pointer orecord, // RECORD*
                byte[] FingerprintImage,
                int FPImageSize,
                int FPImageWidth,
                int FPImageHeight,
                double ScanResolutionPPMM,
                GBAN2K_FingerAmputionsList amp_list,
                GBAN2K_FourFingersBoundsStructure boundaries,
                GBAN2K_FourFingersQualitiesStructure qualities,
                GBAN2K_AlternateQualityList segqual,
                GBAN2K_AlternateQualityList altqual);

        int Get_EFTStype14_Info(
                Pointer orecord, // RECORD*
                Pointer ImagePtr, //byte **
                IntByReference ImageSize, // allocated memory for image frame (can be different from w x h)
                IntByReference w,
                IntByReference h, // image dimensions
                IntByReference PixelDepth, // bits per pixel
                DoubleByReference Resolution_ppmm, // resolution in pixel per mm
                byte[] ImageCompression, // image compression: see definitions: pass a char[10]
                IntByReference ImageImpression, // image impression type (live-scan, roll, etc, see definitions)
                byte[] source_str, // string identifying the originating source of the image,
                // pass a char[44]
                byte[] comment, // comment, pass a char[136]
                byte[] finger_position_list, // list of strings indicating the finger position.
                // See definitions, pass a byte[18]
                // (6 items by 3 chars each)
                Pointer pamp_list, // FING_AMP_LIST**: allocated 
                // by the library
                Pointer pboundaries, // FOUR_FING_BOUND**
                Pointer pqualities, // FOUR_FING_QUALITY**
                Pointer psegqual, // ALT_QUAL_LIST**
                Pointer paltqual // ALT_QUAL_LIST**
                );

        int image2ETFStype_4(
                Pointer orecord, // RECORD**
                byte[] FingerprintImage,
                int FPImageSize,
                int ImpressionType,
                int FingerPosition,
                int ScanResolutionID,
                int FPImageWidth,
                int FPImageHeight,
                String CompressionType);

        int Get_EFTStype4_Info(
                Pointer record,// RECORD*
                Pointer ImagePtr, // unsigned char**
                IntByReference ImageSize,
                IntByReference ImageImpression, // image impression type (live-scan, roll, etc, see definitions)
                int[] finger_position, // pass an int[6]
                IntByReference ImageResolution, // the scan resolution of the fingerprint image. See definitions
                IntByReference w,
                IntByReference h, // image dimensions
                byte[] ImageCompression // image compression: see definitions: pass a char[10]
                );

        int UpdateETFStype_4(
                Pointer record,// RECORD* 
                byte[] FingerprintImage,
                int FPImageSize,
                int ScanResolutionID,
                int FPImageWidth,
                int FPImageHeight);

        int CreateETFStype_2(
                Pointer orecord, // RECORD**
                String Mak,
                String Modl,
                String SerNo,
                GBAN2K_FingerAmputionsList AmputationList);

        int UpdateETFStype_2(
                Pointer record, // RECORD*
                String Mak,
                String Modl,
                String SerNo,
                GBAN2K_FingerAmputionsList AmputationList);

        int Get_EFTStype2_Info(
                Pointer record, // RECORD*
                byte[] Mak, // MAX MAX_MAK_LEN
                byte[] Modl, // MAX MAX_MODL_LEN
                byte[] SerNo, // MAX MAX_SERNO_LEN
                Pointer pamp_list // FING_AMP_LIST**
                );

        int image2ETFStype_15(
                Pointer orecord,// RECORD**
                byte[] PPImage,
                int PPImageSize,
                int PPImageWidth,
                int PPImageHeight,
                int BitsPerPixel,
                double PPImageResolutionPPMM,
                String CompressionType,
                int ImpressionType,
                String ImageSource,
                String Comment,
                String PalmPosition,
                GBAN2K_PalmQualityList PalmQualitiesList);

        int UpdateETFStype_15(
                Pointer orecord,// RECORD*
                byte[] PPImage,
                int PPImageSize,
                int PPImageWidth,
                int PPImageHeight,
                double PPImageResolutionPPMM,
                GBAN2K_PalmQualityList PalmQualitiesList);

        int Get_EFTStype15_Info(
                Pointer orecord,// RECORD*				// input record
                Pointer ImagePtr, // unsigned char**
                IntByReference ImageSize, // allocated memory for image frame (can be different from w x h)
                IntByReference w,
                IntByReference h, // image dimensions
                IntByReference BitsPerPixel, // bits per pixel
                DoubleByReference Resolution_ppmm, // resolution in pixel per mm
                byte[] ImageCompression, // image compression: see definitions: pass a char[10]
                IntByReference ImageImpression, // image impression type (live-scan, roll, etc, see definitions)
                byte[] source_str, // string identifying the originating source of the image, pass a char[44]
                byte[] comment, // comment, pass a char[136]
                byte[] PalmPosition, // string indicating the palm position. See definitions
                Pointer PalmQualitiesList // PALM_QUAL_LIST**
                );

        int insert_ANSI_NIST_record_ETFS(
                int RecordIndex,
                Pointer RecordToBeInserted, // RECORD*
                Pointer ansi_nist // GBAN2K_AnsiNistStructure *
                );

        int delete_ANSI_NIST_record(
                int RecordIndex,
                Pointer ansi_nist // GBAN2K_AnsiNistStructure *
                );

        int read_ANSI_NIST_buffer(
                byte[] buffer,
                int bufLen,
                Pointer oansi_nist // ANSI_NIST**
                );

        int search_ANSI_NIST_record(
                Pointer oRecList, // RECORD_LIST**
                int RecordType,
                GBAN2K_AnsiNistStructure ansi_nist);

        int write_ANSI_NIST_2_buffer(
                Pointer pOutBuffer, // unsigned char **
                IntByReference bufLen,
                GBAN2K_AnsiNistStructure ansi_nist);
        
        void free_ANSI_NIST(
                Pointer ansi_nist // GBAN2K_AnsiNistStructure *
                );
        
        void free_ANSI_NIST_record(
                Pointer record // GBAN2K_RecordStructure *
                );
        
        void free_ANSI_NIST_record_list(
                Pointer record_list // GBAN2K_RecordListStructure *
                );
        
        void free_FOUR_FING_BOUND(
                Pointer boundaries); // GBAN2K_FourFingersBoundsStructure *
        
        void free_FOUR_FING_QUALITY(
                Pointer qualities); // GBAN2K_FourFingersQualitiesStructure*
        
        void free_ANSI_NIST_amp_list(
                Pointer amp_list); // GBAN2K_FingerAmputionsList *
        
        void free_ANSI_NIST_alt_qual_list(
                Pointer alt_qual_list); // GBAN2K_AlternateQualityList*
        
        void free_ANSI_NIST_palm_qual_list(
                Pointer palm_qual_list); // GBAN2K_PalmQualityList*
        
        void free_ANSI_NIST_buffer(Pointer buffer);
        
        int rec_copy(GBAN2K_RecordStructure dst,GBAN2K_RecordStructure src);
    }
}
