/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package GBAN2K_JAVA_Structures;

import com.sun.jna.Structure;
import com.sun.jna.Pointer;

/**
 *
 * @author andrea
 */
public class GBAN2K_FingerSegmentStructure extends Structure {

    public byte[] fing_id;		// one of the below specified finger IDs
    public byte[] left_bound;		// X coordinate of the left boundary
    public byte[] right_bound;	// X coordinate of the right boundary
    public byte[] top_bound;		// Y coordinate of the top boundary
    public byte[] bottom_bound;	// Y coordinate of the bottom boundary

    public GBAN2K_FingerSegmentStructure() {
        this.setAlignType(ALIGN_NONE);
        this.fing_id = new byte[3];
        this.left_bound = new byte[5];
        this.right_bound = new byte[5];
        this.top_bound = new byte[5];
        this.bottom_bound = new byte[5];
    }
    
    @Override
    public Pointer getPointer(){
        this.write();
        Pointer ret = super.getPointer();
        return ret;
    }

    public GBAN2K_FingerSegmentStructure(Pointer p) {
        this();
        if (p == Pointer.NULL) {
            return;
        }
        int offset = 0;
        this.fing_id = p.getByteArray(offset, 3);
        offset += 3;
        this.left_bound = p.getByteArray(offset, 5);
        offset += 5;
        this.right_bound = p.getByteArray(offset, 5);
        offset += 5;
        this.top_bound = p.getByteArray(offset, 5);
        offset += 5;
        this.bottom_bound = p.getByteArray(offset, 5);
    }
}
