/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package GBFINIMG_JAVA_Functions;

import com.sun.jna.Library;
import com.sun.jna.Native;
import com.sun.jna.Pointer;
import com.sun.jna.NativeLong;
import com.sun.jna.ptr.IntByReference;
import com.sun.jna.ptr.ByteByReference;
import com.sun.jna.ptr.PointerByReference;
import com.sun.jna.ptr.DoubleByReference;
import com.sun.jna.ptr.FloatByReference;
import com.sun.jna.ptr.ShortByReference;
import com.sun.jna.WString;
import java.nio.ByteBuffer;

import GBFINIMG_JAVA_Defines.GBFINIMG_MissingFingerDefinitions;
import GBFINIMG_JAVA_Defines.GBFINIMG_SegmentImageDescriptor;
import GBFINIMG_JAVA_Defines.GBFINIMG_SegmentImageExternalInfo;

/**
 *
 * @author andrea
 */
public class GBFINIMG_DllWrapper {

	public interface GBFinImg_Library extends Library {

		GBFinImg_Library INSTANCE =
				(GBFinImg_Library) Native.loadLibrary("GBFINIMG", GBFinImg_Library.class);

		/**
		 * 
		 * @param MissingFingerMask
		 * @see GBFINIMG_JAVA_Defines.GBFINIMG_MissingFingerDefinitions
		 */
		void GBFINIMG_Slap4_MissingFingers(byte MissingFingerMask);

		/**
		 * 
		 * @param InputImage
		 * @param InputSizeX
		 * @see GBFINIMG_JAVA_Defines.GBFINIMG_InputImageSizeLimits
		 * @param InputSizeY
		 * @see GBFINIMG_JAVA_Defines.GBFINIMG_InputImageSizeLimits
		 * @param InputImageType
		 * @see GBFINIMG_JAVA_Defines.GBFINIMG_InputImageTypes
		 * @param ImageProcessingOption
		 * @see GBFINIMG_JAVA_Defines.GBFINIMG_ProcessingOptions
		 * @param SegmentImageList
		 * @param SegmentImageSizeX
		 * @param SegmentImageSizeY
		 * @param DetectedSegmentImageNumber
		 * @param DetectionFailureDiagnostic
		 * @see GBFINIMG_JAVA_Defines.GBFINIMG_SegmentationDiagnostics
		 * @param ExternalInfoList
		 * @param ExternalInfoListSize
		 * @param TempBuffer
		 * @param TempBufferSize
		 * @see GBFINIMG_JAVA_Defines.GBFINIMG_MemoryBufferSize
		 * @return
		 * @see GBFINIMG_JAVA_Defines.GBFINIMG_ReturnCodes
		 */
		int GBFINIMG_ProcessImage(
				byte[] InputImage,
				int InputSizeX,
				int InputSizeY,
				int InputImageType,
				int ImageProcessingOption,
				GBFINIMG_SegmentImageDescriptor[] SegmentImageList,
				int SegmentImageSizeX,
				int SegmentImageSizeY,
				IntByReference DetectedSegmentImageNumber,
				IntByReference DetectionFailureDiagnostic,
				GBFINIMG_SegmentImageExternalInfo[] ExternalInfoList,
				int ExternalInfoListSize,
				byte[] TempBuffer,
				int TempBufferSize);
		
		/**
		 * 
		 * @return detected fingerprints number 
		 */
		int GBFINIMG_GetFingerprintCounter();
		
		/**
		 * 
		 * @param Probability
		 * @param PatternDiagnostic 
		 */
		void  GBFINIMG_CheckFingerRotation180Degree(
				IntByReference Probability,
				ByteByReference PatternDiagnostic);
	}
}
