/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package GBFINIMG_JAVA_Defines;

/**
 *
 * @author andrea
 */
public class GBFINIMG_ProcessingOptions {

    public static int GBFINIMG_HALO_LATENT_ELIMINATION = 0x00000001;
    // Wipes halo-effect/latent-prints in <InputImage> buffer around fingerprint segments.
    public static int GBFINIMG_SEGMENT_VERTICAL_ROTATION = 0x00000002;
    //Rotates segmented images in <SegmentImageList[].SegmentImagePtr> to the vertical position.
    //NOTE: this operation requires "GBImgTran.dll" to be allocated
    //      in the same directory with "GBFINIMG.DLL".
    //VER3000: for half-palm images the rotation will not be applied 
    //		   in a case when the system is unable detect if a hand is left or right:
    //         (GBFINIMG_SEGMENT_IMAGE_DESCRIPTOR.Hand == GBFINIMG_HAND_UNDEFINED)
    public static int GBFINIMG_PALM_PRINT_IMAGE_DELETE_FINGER_SEGMENTS = 0x00000004; //VER3000
    // Deletes eventual fingerprint segments found around palm-prints in <InputImage> buffer. 
    // Recommended to be used.
    // This option is effective just for palm-print image types and only together with
    //  option GBFINIMG_HALO_LATENT_ELIMINATION
    public static int GBFINIMG_PALM_PRINT_IMAGE_QUALITY_CALCULATION = 0x00000008; //VER3000
    // Enables complete palm-print image processing that provides parameters of quality of
    //	 palm-print image (GBFINIMG_SEGMENT_IMAGE_DESCRIPTOR.PatternValidity and  
    //	 GBFINIMG_SEGMENT_IMAGE_DESCRIPTOR.Quality)
    // ATTENTION: due to big size of palm-prints, activating this option will result in 
    //			  significantly longer processing time.
    public static int GBFINIMG_1000DPI_PRINT_IMAGE_PROCESSING = 0x00000010; //VER3000-1000DPI
    // Allows to process 1000-dpi print images. If this option is set:  
    //	- the resolution of <InputImage> will be considered as 1000 dpi instead of 500 dpi
    //	- <InputSizeX> is limited by GBFINIMG_MAX_INPUT_SIZE_X_1000DPI 
    //	- <InputSizeY> is limited by GBFINIMG_MAX_INPUT_SIZE_Y_1000DPI 
    //  If this option is set together with GBFINIMG_SEGMENT_VERTICAL_ROTATION, an auxiliary 
    //	   buffer will be required for rotation operation, see GBFINIMG_SetRotationBuffer1000DPI()
    //	   function description.
    public static int GBFINIMG_FAST_PROCESSING_SEGMENT_NUMBER_ONLY = 0x00000020; //VER3002
    // Allows to process fingerprint images in a faster way omitting some processing steps.
    // Attention: if this option is set: 
    // 1. application can use only  <*DetectedSegmentImageNumber> and <*DetectionFailureDiagnostic> 
    //    output parameters (with one exception - <*DetectionFailureDiagnostic> output parameters 
    //    in this case CAN NOT be used for writer's palm).
    // 2. Output parameter <SegmentImageList> CAN NOT BE USED for any kind of <InputImageType>!!!!
    // 3. The following other options will be ignored:
    //		- GBFINIMG_HALO_LATENT_ELIMINATION
    //		- GBFINIMG_SEGMENT_VERTICAL_ROTATION
    //		- GBFINIMG_PALM_PRINT_IMAGE_QUALITY_CALCULATION
    public static int GBFINIMG_DISABLE_LEFT_RIGHT_HAND_MIXUP_CHECK = 0x00000040;//VER3002
    // Can be useful for the cases when application/operator itself ensures that applied hand 
    //  corresponds to the requested one (there is no surely left-right hand mix-up).
    // If this option is set, GBFINIMG_ProcessImage() function does not try to verify the hipotesis
    //	of hand mix-up and this fact improves the performnace of GBFINIMG_GetFingerprintCounter()
    //  function (decreases error rate) especially in cases of non-complete slaps (when one or more 
    //	fingers of a slap are absent/bandaged). 
    //  This option is supported only for the following <InputImageType>:
    //			- GBFINIMG_INPUT_IMAGE_TYPE_LEFT_HAND_4 
    //			- GBFINIMG_INPUT_IMAGE_TYPE_RIGHT_HAND_4 
    public static int GBFINIMG_FAST_PROCESSING_PRELIMINARY_SEGMENT_DATA = 0x00000080;
    // Allows to process fingerprint images in a faster way omitting some processing steps (similar to 
    //   GBFINIMG_FAST_PROCESSING_SEGMENT_NUMBER_ONLY option).
    // Attention: if this option is set: 
    // 1. application can use <*DetectedSegmentImageNumber> and <*DetectionFailureDiagnostic> 
    //    output parameters (with one exception - <*DetectionFailureDiagnostic> output parameters 
    //    in this case CAN NOT be used for writer's palm) and output parameter <SegmentImageList>.
    //   In difference from GBFINIMG_FAST_PROCESSING_SEGMENT_NUMBER_ONLY, if this option is set,
    //    <SegmentImageList> data will be generated and it will contain valid information 
    //    for all fields except for these: 
    //			SegmentImageList[].SegmentImagePtr			- separate segment image is NOT AVAILABLE
    //			SegmentImageList[].PatternValidity			- NOT AVAILABLE
    //			SegmentImageList[].PatternCompleteness		- NOT AVAILABLE
    //	  Note: all available fields in SegmentImageList are results of "fast" processing, so, in some cases "fast" results
    //			can differ from "complete" processing results.
    // 2. The following other options will be ignored:
    //      - GBFINIMG_FAST_PROCESSING_SEGMENT_NUMBER_ONLY
    //		- GBFINIMG_HALO_LATENT_ELIMINATION
    //		- GBFINIMG_SEGMENT_VERTICAL_ROTATION
    //		- GBFINIMG_PALM_PRINT_IMAGE_QUALITY_CALCULATION
}
