/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package GBFIR_JAVA_Functions;

import com.sun.jna.Library;
import com.sun.jna.Native;
import com.sun.jna.Pointer;
import com.sun.jna.NativeLong;
import com.sun.jna.ptr.IntByReference;
import com.sun.jna.ptr.ByteByReference;
import com.sun.jna.ptr.PointerByReference;
import com.sun.jna.ptr.DoubleByReference;
import com.sun.jna.ptr.FloatByReference;
import com.sun.jna.ptr.ShortByReference;
import com.sun.jna.WString;
import java.nio.ByteBuffer;

/**
 *
 * @author andrea
 */
public class GBFIR_DllWrapper {

	public interface GBFIR_Library extends Library {

		GBFIR_Library INSTANCE =
				(GBFIR_Library) Native.loadLibrary("GBFIR", GBFIR_Library.class);

		/**
		 * 
		 * @param Type
		 * @param ImageAcquisitionLevel
		 * Native is an uint16
		 * see point (1) of ReadME.txt file
		 * @param CBEFFProductId
		 * @param CaptureDeviceID
		 * Native is an uint16
		 * see point (1) of ReadME.txt file
		 * @param ScaleUnits
		 * @param ScanResolutionH
		 * Native is an uint16
		 * see point (1) of ReadME.txt file
		 * @param ScanResolutionV
		 * Native is an uint16
		 * see point (1) of ReadME.txt file
		 * @param ImageResolutionH
		 * Native is an uint16
		 * see point (1) of ReadME.txt file
		 * @param ImageResolutionV
		 * Native is an uint16
		 * see point (1) of ReadME.txt file
		 * @param PixelDepth
		 * @param ImageCompressionAlgorithm
		 * @return 
		 */
		int GBFIR_CreateFIR(
				int Type,
				short ImageAcquisitionLevel, // u
				byte[] CBEFFProductId,
				short CaptureDeviceID, // u 
				byte ScaleUnits,
				short ScanResolutionH, // u
				short ScanResolutionV, // u
				short ImageResolutionH, // u
				short ImageResolutionV, // u
				byte PixelDepth,
				byte ImageCompressionAlgorithm);

		/**
		 * 
		 * @param ImageBuffer
		 * @param BufferLen
		 * @param ImageWidth
		 * @param ImageHeight
		 * @param CountView
		 * @param ViewNumber
		 * @param ImageQuality
		 * @param FingerPosition
		 * @param ImpressionType
		 * @return 
		 */
		int GBFIR_AddImageToFIR(byte[] ImageBuffer,
				int BufferLen, int ImageWidth, int ImageHeight,
				byte CountView,
				byte ViewNumber,
				int ImageQuality, int FingerPosition, int ImpressionType);

		/**
		 * 
		 * @return FIR buffer size
		 */
		int GBFIR_GetFIRLen();

		/**
		 * 
		 * @param FIRBuffer allocated externally, must be >= than the value
		 * returned by GBFIR_GetFIRLen
		 * @return 
		 */
		int GBFIR_WriteFIRToBuffer(byte[] FIRBuffer);

		/**
		 * 
		 * @param FIRBuffer
		 * @param BufferLen
		 * @param Type
		 * @return 
		 */
		int GBFIR_ReadFIRFromBuffer(
				byte[] FIRBuffer, int BufferLen, int Type);

		/**
		 * 
		 * @param ImageAcquisitionLevel
		 * Native is an uint16
		 * see point (1) of ReadME.txt file
		 * @param CBEFFProductId
		 * @param CaptureDeviceID
		 * Native is an uint16
		 * see point (1) of ReadME.txt file
		 * @param ScaleUnits
		 * Native is an uint16
		 * see point (1) of ReadME.txt file
		 * @param ScanResolutionH
		 * Native is an uint16
		 * see point (1) of ReadME.txt file
		 * @param ScanResolutionV
		 * Native is an uint16
		 * see point (1) of ReadME.txt file
		 * @param ImageResolutionH
		 * Native is an uint16
		 * see point (1) of ReadME.txt file
		 * @param ImageResolutionV
		 * Native is an uint16
		 * see point (1) of ReadME.txt file
		 * @param PixelDepth
		 * @param ImageCompressionAlgorithm
		 * @return 
		 */
		int GBFIR_GetFIRHeaderFields(
				ShortByReference ImageAcquisitionLevel, // u
				byte[] CBEFFProductId,
				ShortByReference CaptureDeviceID, // u
				ByteByReference ScaleUnits, // u
				ShortByReference ScanResolutionH, // u
				ShortByReference ScanResolutionV, // u
				ShortByReference ImageResolutionH, // u
				ShortByReference ImageResolutionV, // u
				ByteByReference PixelDepth,
				ByteByReference ImageCompressionAlgorithm);

		/**
		 * 
		 * @return number of fingers in the FIR record
		 */
		int GBFIR_GetNumberOfFingers();

		/**
		 * 
		 * @param Index
		 * @param CountView
		 * @param ViewNumber
		 * @param ImageQuality
		 * @param FingerPosition
		 * @param ImpressionType
		 * @return 
		 */
		int GBFIR_GetFingerRecordHeaderFields(
				int Index,
				ByteByReference CountView,
				ByteByReference ViewNumber,
				IntByReference ImageQuality,
				IntByReference FingerPosition,
				IntByReference ImpressionType);

		/**
		 * 
		 * @param Index
		 * @param ImageBufferSize
		 * @return 
		 */
		int GBFIR_GetFingerImageSize(int Index, IntByReference ImageBufferSize);
		
		/**
		 * 
		 * @param Index
		 * @param ImageBuffer
		 * @param ImageWidth
		 * @param ImaheHeight
		 * @return 
		 */
		int GBFIR_GetFingerImage(
			int Index, byte [] ImageBuffer, 
			IntByReference ImageWidth, IntByReference ImaheHeight);
		
		/**
		 * 
		 */
		void GBFIR_FreeFIR ();
	}
}
